

## attention, il faut revoir la fonction quand le slot nona est rempli dans l'objet protPep

mcq.drop <-function (object, factor=factor, levels=levels) {
	if (is.null(levels) | is.null(factor) ) {
		stop("Please fill in the 'factor' and 'levels' arguments.\n")
	} else {
		if (!is.vector(levels)) {
			levels <- c(levels)
		}
	}

	if (class(object) == "mcqProtPep") {
		peptide_col_names = c("group", "msrun","mz" ,"rt","maxintensity","area","rtbegin","rtend","peptide","isotope","sequence","z","mods", "nilevel", "nirank", "niratio")
		metadata_col_names=colnames(object@metadata@metadata)
		protein_col_names=c("protein", "accession")
		nbpeptides <- length(unique(object@peptides$peptide))
		nbprot <- length(unique(object@proteins$protein))
		nbsamples <- length(unique(object@peptides$msrun))

		if (factor %in% peptide_col_names) {

			if (sum(!levels %in% unique(object@peptides[,factor]))>0){
				bad.levels=levels[!levels %in% unique(object@peptides[,factor])]
				cat (paste("The levels ", bad.levels, " are not in the factor ", factor, ".\n", sep=""))
			}else{
				cat (paste("Dropping the levels ", levels, " of factor ", factor, ".\n", sep=""))

				cat ("Updating peptide data.\n")
				peptide_ok <- !(object@peptides[,factor]  %in% levels)
				object@peptides <- object@peptides[peptide_ok,]

				cat ("Updating protein data.\n")
				object@proteins <- object@proteins[object@proteins$peptide %in% object@peptides$peptide,]

				if (nrow(object@metadata@metadata) > 0){
					cat ("Updating metadata.\n")
					object@metadata@metadata <- object@metadata@metadata[rownames(object@metadata@metadata) %in% unique(object@peptides$msrun),]

					object@metadata@samples$msrun <- rownames(object@metadata@samples)
					object@metadata@samples <-object@metadata@samples[rownames(object@metadata@samples) %in% rownames(object@metadata@metadata),]
					object@metadata@samples$msrun <- NULL
				}
			}

		} else if (factor %in% metadata_col_names) {

			if (sum(!levels %in% unique(object@metadata@metadata[,factor]))>0){
				bad.levels=levels[!levels %in% unique(object@metadata@metadata[,factor])]
				cat (paste("The levels ", bad.levels, " are not in the factor ", factor, ".\n", sep=""))
			}else{
				cat (paste("Dropping the levels ", levels, " of factor ", factor, ".\n", sep=""))

				cat ("Updating metadata.\n")
				msrunListToDrop <- rownames(object@metadata@metadata[object@metadata@metadata[,factor] %in% levels,])
				object@metadata@metadata <- object@metadata@metadata[!(rownames(object@metadata@metadata) %in% msrunListToDrop),]

				object@metadata@samples$msrun <- rownames(object@metadata@samples)
				object@metadata@samples <-object@metadata@samples[rownames(object@metadata@samples) %in% rownames(object@metadata@metadata),]
				object@metadata@samples$msrun <- NULL

				cat ("Updating peptide data.\n")
				object@peptides <- object@peptides[!(object@peptides$msrun %in% msrunListToDrop),]

				cat ("Updating protein data.\n")
				object@proteins <- object@proteins[object@proteins$peptide %in% object@peptides$peptide,]
			}

		} else if (factor %in% protein_col_names) {

			if (sum(!levels %in% unique(object@proteins[,factor]))>0){
				bad.levels=levels[!levels %in% unique(object@proteins[,factor])]
				cat (paste("The levels ", bad.levels, " are not in the factor ", factor, ".\n", sep=""))
			}else{
				cat (paste("Dropping the levels ", levels, " of factor ", factor, ".\n", sep=""))
				pepToDrop=object@proteins$peptide[object@proteins[, factor] %in% levels]

				cat ("Updating protein data.\n")
				object@proteins <- object@proteins[!object@proteins$peptide %in% pepToDrop,]

				cat ("Updating peptide data.\n")
				object@peptides <- object@peptides[(object@peptides$peptide %in% unique(object@proteins$peptide)),]

				if (nrow(object@metadata@metadata) > 0){
					cat ("Updating metadata.\n")
					object@metadata@metadata <- object@metadata@metadata[rownames(object@metadata@metadata) %in% unique(object@peptides$msrun),]

					object@metadata@samples$msrun <- rownames(object@metadata@samples)
					object@metadata@samples <-object@metadata@samples[rownames(object@metadata@samples) %in% rownames(object@metadata@metadata),]
					object@metadata@samples$msrun <- NULL
				}
			}

		}else{
			if (!factor %in% c(peptide_col_names, protein_col_names, metadata_col_names)){
				stop(paste("The factor ", factor, " is not described in your data.\n", sep=""))
			}
		}

		nbpeptidesafter <- length(unique(object@peptides$peptide))
		nbprotafter <- length(unique(object@proteins$protein))
		nbsamplesafter <- length(unique(object@peptides$msrun))
		cat (paste((nbpeptides - nbpeptidesafter), " peptides dropped.\n", sep=""))
		cat (paste((nbprot - nbprotafter), " protein(s) dropped.\n", sep=""))
		cat (paste((nbsamples - nbsamplesafter), " samples(s) dropped.\n", sep=""))

	} else if(class(object) == "mcq.spectralcounting" | class(object) == "mcq.peakcounting") {

		protval_col_names = c("protein", "msrun")
		metadata_col_names=colnames(object@metadata@metadata)
		protein_col_names=c("accession")
		nbprot <- length(unique(object@protval$protein))
		nbsamples <- length(unique(object@samples$msrunfile))

		if(factor %in% protval_col_names) {

			if (sum(!levels %in% unique(object@protval[,factor]))>0){
				bad.levels=levels[!levels %in% unique(object@protval[,factor])]
				cat (paste("The levels ", bad.levels, " are not in the factor ", factor, ".\n", sep=""))
			}else{
				cat (paste("Dropping the levels ", levels, " of factor ", factor, ".\n", sep=""))

				cat ("Updating protein data.\n")
				object@protval <- object@protval[!(object@protval[,factor] %in% levels),]


				if (class(object) == "mcq.spectralcounting"){
					object@proteins <- object@proteins[object@proteins$accession %in% unique(object@protval$protein),]
				}else{
					object@proteins <- object@proteins[rownames(object@proteins) %in% unique(object@protval$protein),]
				}

				cat ("Updating metadata.\n")
				object@metadata@metadata <- object@metadata@metadata[(rownames(object@metadata@metadata) %in% unique(object@protval$msrun)),]

				object@metadata@samples$msrun <- rownames(object@metadata@samples)
				object@metadata@samples <-object@metadata@samples[rownames(object@metadata@samples) %in% rownames(object@metadata@metadata),]
				object@metadata@samples$msrun <- NULL

				object@samples$msrun <- rownames(object@samples) 
				object@samples <- object@samples[rownames(object@samples) %in% rownames(object@metadata@metadata),]
				object@samples$msrun <- NULL
			}

		}else if (factor %in% metadata_col_names) {
		
			if (sum(!levels %in% unique(object@metadata@metadata[,factor]))>0){
				bad.levels=levels[!levels %in% unique(object@metadata@metadata[,factor])]
				cat (paste("The levels ", bad.levels, " are not in the factor ", factor, ".\n", sep=""))
			}else{
				cat (paste("Dropping the levels ", levels, " of factor ", factor, ".\n", sep=""))

				cat ("Updating metadata.\n")
				msrunListToDrop <- rownames(object@metadata@metadata[object@metadata@metadata[,factor] %in% levels,])
				object@metadata@metadata <- object@metadata@metadata[!(rownames(object@metadata@metadata) %in% msrunListToDrop),]

				object@metadata@samples$msrun <- rownames(object@metadata@samples)
				object@metadata@samples <-object@metadata@samples[rownames(object@metadata@samples) %in% rownames(object@metadata@metadata),]
				object@metadata@samples$msrun <- NULL

				object@samples$msrun <- rownames(object@samples) 
				object@samples <- object@samples[rownames(object@samples) %in% rownames(object@metadata@metadata),]
				object@samples$msrun <- NULL

				cat ("Updating protein data.\n")
				object@protval <- object@protval[!(object@protval$msrun %in% msrunListToDrop),]

				if (class(object) == "mcq.spectralcounting"){
					object@proteins <- object@proteins[object@proteins$accession %in% unique(object@protval$protein),]
				}else{
					object@proteins <- object@proteins[rownames(object@proteins) %in% unique(object@protval$protein),]
				}
			}	

		} else if (factor %in% protein_col_names) {
		
			if (sum(!levels %in% unique(object@proteins[,factor]))>0){
				bad.levels=levels[!levels %in% unique(object@proteins[,factor])]
				cat (paste("The levels ", bad.levels, " are not in the factor ", factor, ".\n", sep=""))
			}else{
				cat (paste("Dropping the levels ", levels, " of factor ", factor, ".\n", sep=""))

				cat ("Updating protein data.\n")
				object@proteins <- object@proteins[!object@proteins[,factor] %in% levels,]
				
				if (class(object) == "mcq.spectralcounting"){
					object@protval <- object@protval[!object@protval$protein %in% levels,]
				}else{
					object@protval <- object@protval[object@protval$protein %in% rownames(object@proteins),]
				}

				cat ("Updating metadata.\n")
				object@metadata@metadata <- object@metadata@metadata[(rownames(object@metadata@metadata) %in% unique(object@protval$msrun)),]

				object@metadata@samples$msrun <- rownames(object@metadata@samples)
				object@metadata@samples <-object@metadata@samples[rownames(object@metadata@samples) %in% rownames(object@metadata@metadata),]
				object@metadata@samples$msrun <- NULL

				object@samples$msrun <- rownames(object@samples) 
				object@samples <- object@samples[rownames(object@samples) %in% rownames(object@metadata@metadata),]
				object@samples$msrun <- NULL
			}
		}else{
			if (!factor %in% c(protval_col_names, protein_col_names, metadata_col_names)){
				stop(paste("The factor ", factor, " is not described in your data.\n", sep=""))
			}
		}

		nbprotafter <- length(unique(object@protval$protein))
		nbsamplesafter <- length(unique(object@samples$msrunfile))
		cat (paste((nbprot - nbprotafter), " protein(s) dropped.\n", sep=""))
		cat (paste((nbsamples - nbsamplesafter), " samples(s) dropped.\n", sep=""))

	}else if (class(object) == "mcq.protquantity") {
		protval_col_names = c("protein", "msrun")
		metadata_col_names = colnames(object@metadata@metadata)
		protein_col_names=c("accession")
		nbprot <- length(unique(object@protval$protein))
		nbsamples <- length(unique(object@samples$msrunfile))

		if(factor %in% protval_col_names) {

			if (sum(!levels %in% unique(object@protval[,factor]))>0){
				bad.levels=levels[!levels %in%  unique(object@protval[,factor])]
				cat (paste("The levels ", bad.levels, " are not in the factor ", factor, ".\n", sep=""))
			}else{
				cat (paste("Dropping the levels ", levels, " of factor ", factor, ".\n", sep=""))

				cat ("Updating protein data.\n")
				object@protval <- object@protval[!(object@protval[,factor] %in% levels),]

				object@proteins <- object@proteins[rownames(object@proteins) %in% unique(object@protval$protein),]

				cat ("Updating metadata.\n")
				if (nrow(object@metadata@metadata) > 0){
					object@metadata@metadata <- object@metadata@metadata[rownames(object@metadata@metadata) %in% unique(object@protval$msrun),]

					object@metadata@samples$msrun <- rownames(object@metadata@samples)
					object@metadata@samples <-object@metadata@samples[rownames(object@metadata@samples) %in% rownames(object@metadata@metadata),]
					object@metadata@samples$msrun <- NULL
				}

				object@samples$msrun <- rownames(object@samples)
				object@samples <- object@samples[rownames(object@samples) %in% unique(object@protval$msrun),]
				object@samples$msrun <- NULL
			}

		} else if  (factor %in% protein_col_names) {

			cat ("Updating proteins\n")
			object@proteins <- object@proteins[!object@proteins$accession %in% levels,]
			object@protval <- object@protval[(object@protval$protein %in% rownames(object@proteins)),]

			if (nrow(object@metadata@metadata) > 0){
				cat ("Updating metadata\n")
				object@metadata@metadata <- object@metadata@metadata[!(rownames(object@metadata@metadata) %in% levels),]

				object@metadata@samples$msrun <- rownames(object@metadata@samples)
				object@metadata@samples <-object@metadata@samples[rownames(object@metadata@samples) %in% rownames(object@metadata@metadata),]
				object@metadata@samples$msrun <- NULL
			}

			object@samples$msrun <- rownames(object@samples)
			object@samples <- object@samples[rownames(object@samples) %in% unique(object@protval$msrun),]
			object@samples$msrun <- NULL

		} else if (factor %in% metadata_col_names) {

			if (sum(!levels %in% unique(object@metadata@metadata[,factor]))>0){
				bad.levels=levels[!levels %in%  unique(object@metadata@metadata[,factor])]
				cat (paste("The levels ", bad.levels, " are not in the factor ", factor, ".\n", sep=""))
			}else{
				cat (paste("Dropping the levels ", levels, " of factor ", factor, ".\n", sep=""))

				cat ("Updating metadata.\n")
				msrunListToDrop <- rownames(object@metadata@metadata[object@metadata@metadata[,factor] %in% levels,])
				object@metadata@metadata <- object@metadata@metadata[!(rownames(object@metadata@metadata) %in% msrunListToDrop),]

				object@metadata@samples$msrun <- rownames(object@metadata@samples)
				object@metadata@samples <-object@metadata@samples[rownames(object@metadata@samples) %in% rownames(object@metadata@metadata),]
				object@metadata@samples$msrun <- NULL

				object@samples$msrun <- rownames(object@samples)
				object@samples <- object@samples[!rownames(object@samples) %in% msrunListToDrop,]
				object@samples$msrun <- NULL

				cat ("Updating protein data.\n")
				object@protval <- object@protval[!(object@protval$msrun %in% msrunListToDrop),]

				object@proteins <- object@proteins[rownames(object@proteins) %in% unique(object@protval$protein),]
		
			}
	
		}else{
			if (!factor %in% c(protval_col_names, protein_col_names, metadata_col_names)){
				stop(paste("The factor ", factor, " is not described in your data.\n", sep=""))
			}
		}

		nbprotafter <- length(unique(object@protval$protein))
		nbsamplesafter <- length(unique(object@samples$msrunfile))
		cat (paste((nbprot - nbprotafter), " protein(s) dropped.\n", sep=""))
		cat (paste((nbsamples - nbsamplesafter), " samples(s) dropped.\n", sep=""))
	
	}else {
		stop(paste("The class \"", class(object),"\" is not taken into account by mcq.drop.",sep=""))
	}
	return (object)
}
