
mcq.drop.protquantity.sd= function (object, cutoff) {
	if (class(object) == "mcq.protquantity") {

		proteingroup=as.factor(object@protval$protein)
		## Calculation of the standard deviation of retention time
		sdrt=aggregate(object@protval$q,list(proteingroup),FUN=sd)

		## Removal of peptiz which the standard deviation of the retention time is too high (greater than the parameter "cutoff" 15 (20?). They certainly corresponds to a mismatch
		thr_sdrt=cutoff 
		badprot=sdrt[!is.na(sdrt$x) & sdrt$x<thr_sdrt,] 
		badprot=drop.levels(badprot$Group.1)
		cat (paste(length(badprot), " proteins dropped\n"))

		object@protval <- subset(object@protval, !protein %in% badprot)
		protok <- unique(object@protval$protein)
		object@proteins <- object@proteins[protok,]
		rownames(object@proteins) <- protok

		return (object)

	}
	else {
		stop("input is not an mcq.protquantity object")
	}
}


