
mcq.drop.variable.rt <- function (object, cutoff=20) {

	if (class(object) == "mcqProtPep") {
		sdrt=aggregate(object@peptides$rt,list(object@peptides$peptiz),FUN=sd)
	}
	else if (class(object) == "mcq.skyline") {
		sdrt=aggregate(object@peptides$rt,list(object@peptides$peptide),FUN=sd)
	}
	else {
		stop("Input is not an object of class mcqProtPep or mcq.skyline.")

	}

	bad.pep=sdrt[!is.na(sdrt$x) & sdrt$x>cutoff,"Group.1"] 
	cat (paste(length(bad.pep), " peptides-charge dropped because of too much variation in their retention time\n", sep=""))

	nbpeptides.before <- length(unique(object@peptides$peptide))
	object@peptides <- object@peptides[!(object@peptides$peptiz %in% bad.pep),]
	nbpeptides.after <- length(unique(object@peptides$peptide))
	cat (paste("corresponding to ", (nbpeptides.before - nbpeptides.after), " peptides\n", sep=""))
	nbprot.before <- length(unique(object@proteins$protein))
	object@proteins <- object@proteins[object@proteins$peptide %in% object@peptides$peptide,]
	nbprot.after <- length(unique(object@proteins$protein))
	cat (paste("corresponding to ", (nbprot.before - nbprot.after), " proteins\n", sep=""))

	if (nrow(object@metadata@metadata) > 0){
		object@metadata@metadata <- object@metadata@metadata[rownames(object@metadata@metadata) %in% unique(object@peptides$msrun),]

		object@metadata@samples$msrun <- rownames(object@metadata@samples)
		object@metadata@samples <-object@metadata@samples[rownames(object@metadata@samples) %in% rownames(object@metadata@metadata),]
		object@metadata@samples$msrun <- NULL
	}
	
	return (object)
}

