
mcq.drop.wide.peaks <- function (object, cutoff=100) {
	if (class(object) == "mcqProtPep") {
		width_peak_ok <- ((object@peptides[,'rtend'] - object@peptides[,'rtbegin']) <= cutoff)
		nbquanti.before <- nrow(object@peptides)		
		nbpeptides.before <- length(unique(object@peptides$peptide))
		nbprot.before <- length(unique(object@proteins$protein))

		object@peptides <- object@peptides[width_peak_ok,]

		object@proteins <- object@proteins[object@proteins$peptide %in% unique(object@peptides$peptide),]

		if (nrow(object@metadata@metadata) > 0){
			object@metadata@metadata <- object@metadata@metadata[unique(object@peptides$msrun),]

			object@metadata@samples$msrun <- rownames(object@metadata@samples)
			object@metadata@samples <-object@metadata@samples[rownames(object@metadata@samples) %in% rownames(object@metadata@metadata),]
			object@metadata@samples$msrun <- NULL
		}

		nbquanti.after <- nrow(object@peptides)	
		nbpeptides.after <- length(unique(object@peptides$peptide))
		nbprot.after <- length(unique(object@proteins$protein))
		cat (paste((nbquanti.before - nbquanti.after), " chromatographic peaks dropped because they are two wide\n", sep=""))
		cat (paste("resulting in the loss of ", (nbpeptides.before - nbpeptides.after), " peptides and ", (nbprot.before - nbprot.after), " proteins\n", sep=""))

		return (object)
	}
	else {
		stop(paste("The class of the input object (",class(object),") is not taken into account by mcq.drop.wide.peaks."))
	}
}

