
mcq.export.metadata.template = function(object, file=NULL) {
	if (class(object) == "mcqProtPep") {
		tab_sample_id = unique(object@peptides[,'msrun'])

		metadata = data.frame(
				msrun=character(length(tab_sample_id)),
				stringsAsFactors=FALSE)

		metadata$msrun <- tab_sample_id

		tabmsrunfile = unique(object@peptides[,c('msrun','msrunfile')])
		metadata<-merge(metadata,tabmsrunfile, by="msrun", all.x=TRUE)
	}
	else if (class(object) == "mcq.skyline") {
		tab_sample_id = unique(object@peptides[,'msrun'])

		metadata = data.frame(
				msrun=character(length(tab_sample_id)),
				stringsAsFactors=FALSE)

		metadata$msrun <- tab_sample_id

		tabmsrunfile <- metadata
		tabmsrunfile$msrunfile <- metadata$msrun
		metadata<-merge(metadata,tabmsrunfile, by="msrun", all.x=TRUE)

	}
	else if (class(object) == "mcq.spectralcounting") {
		if (!('msrun' %in% colnames(object@protval))) {
			msrunfileList <- unique (object@protval$msrunfile)
			msrunnames <- paste ("samp", seq(1:length(msrunfileList)), sep="")
			dfmsrun <- data.frame(msrunfile=msrunfileList, msrun=msrunnames)

			object@protval <- merge(object@protval, dfmsrun, by="msrunfile")
		}
		tab_sample_id = unique(object@protval[,'msrun'])

		metadata = data.frame(
				msrun=character(length(tab_sample_id)),
				stringsAsFactors=FALSE)

		metadata$msrun <- tab_sample_id

		tabmsrunfile = unique(object@protval[,c('msrun','msrunfile')])
		metadata<-merge(metadata,tabmsrunfile, by="msrun", all.x=TRUE)
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcqWriteMetadataCsv",sep=""))
	}
	write.table(metadata, file,quote= FALSE, sep="\t",row.names=FALSE)
}




