

mcq.get.compar <-function (object, flist=NULL, na.rm=TRUE, sampleid=TRUE,good.model=0.01) {

	if (!is.null(flist)) {
		if (is.vector(flist)) {

		}
		else {
			flist <- c(flist);
		}
	}

	if (priv.mcq.is.protquant.object(object)) {
		tab <- object@protval[,c("protein", "msrun","q")]
		tab <- merge (tab, object@proteins, by.x="protein", by.y="row.names")

		if (is.null(flist)) {

			if (sampleid) {
				tab <- tapply(tab$q,list(tab$accession,tab$msrun),FUN=mean,na.rm=na.rm)
			}
			else {
				tab <- merge (tab, object@samples, by.x="msrun", by.y="row.names")
				tab <- tapply(tab$q,list(tab$accession,tab$msrunfile),FUN=mean,na.rm=na.rm)
			}

			if ((class(object) == "mcq.peakcounting")|| (class(object) == "mcq.spectralcounting")) {
				#rename q to count :
				colnames(tab)[colnames(tab) == "q"] <- "count"
			}

			return (as.data.frame(tab))
		}
		else {
			for (factor in flist) {
				if(factor %in% names(object@metadata@metadata)) {
				}else {
					stop(paste("factor ", factor, " is not described in your metadata\n", "available factors are : ", paste(colnames(object@metadata@metadata),collapse=", "), "\n", sep=""))
				}
			}


			object@metadata@metadata$msrun <- rownames(object@metadata@metadata)
			tab <- merge(tab, object@metadata@metadata, by="msrun")

			if (length(flist)>1) {
				tab$regroup <- apply( tab[ , colnames(tab) %in% flist] , 1 , paste , collapse = "-" )
			} else {
				tab$regroup <- tab[ ,flist]
			}
			tab <- tapply(tab$q,list(tab$accession,tab$regroup),FUN=mean,na.rm=na.rm)

			if ((class(object) == "mcq.peakcounting")|| (class(object) == "mcq.spectralcounting")) {
				#rename q to count :
				colnames(tab)[colnames(tab) == "q"] <- "count"
			}

			return (as.data.frame(tab))
		}
	}
	else if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")){
		if("lognorm" %in% colnames(object@nona)) {
			tab <- object@nona[,c("peptiz", "msrun","lognorm")]
			colnames(tab)[colnames(tab) == "lognorm"] <- "q"
		}
		else if (is.null(object@peptides$lognorm)) {
			tab <- object@peptides[,c("peptiz", "msrun","logarea")]
			colnames(tab)[colnames(tab) == "logarea"] <- "q"
		}
		else {
			tab <- object@peptides[,c("peptiz", "msrun","lognorm")]
			colnames(tab)[colnames(tab) == "lognorm"] <- "q"
		}

		if (is.null(flist)) {
			tab <- tapply(tab$q,list(tab$peptiz,tab$msrun),FUN=mean,na.rm=na.rm)
			return (as.data.frame(tab))
		}
		else {
			for (factor in flist) {
				if(factor %in% names(object@metadata@metadata)) {
				}else {
					stop(paste("factor ", factor, " is not described in your metadata\n", "available factors are : ", paste(colnames(object@metadata@metadata),collapse=", "), "\n", sep=""))
				}
			}


			object@metadata@metadata$msrun <- rownames(object@metadata@metadata)
			tab <- merge(tab, object@metadata@metadata, by="msrun")

			if (length(flist)>1) {
				tab$regroup <- apply( tab[ , colnames(tab) %in% flist] , 1 , paste , collapse = "-" )
			} else {
				tab$regroup <- tab[ ,flist]
			}
			tab <- tapply(tab$q,list(tab$peptiz,tab$regroup),FUN=mean,na.rm=na.rm)
			return (as.data.frame(tab))

		}
	}
	else if (priv.mcq.is.anova.object(object)) {
		## export resultat pour tableur
		anov <- object@resultanov
		factorNameList <- c(object@paramlist$factorList,object@paramlist$interactionList)

		## gestion proba du model glm
		if ((length(colnames(anov))-length(factorNameList)) >0) {
			boolean=NULL
			boolean[which(anov$proba.good.model>=0.01)]="Valid"
			boolean[which(anov$proba.good.model<0.01)]="Not valid"
			anov$proba.good.model=boolean
			colnames(anov)[1]="model"
			if(length(which(anov$model=="Not valid"))>0){cat("WARNING : There is Not valid models in your tab, verify your individuals data quality\n")}
		}
		colnames(anov)[(length(colnames(anov))-length(factorNameList)+1):length(colnames(anov))]<- paste("pval_", colnames(anov)[(length(colnames(anov))-length(factorNameList)+1):length(colnames(anov))], sep="")
		for (factorName in factorNameList) {
				anov[,length(colnames(anov))+1] <- p.adjust(object@resultanov[,factorName],method="BH")
				colnames(anov)[length(anov)]=paste("padj_",factorName,sep="")
		}
		anov <- merge(anov, object@proteins, by.x="row.names", by.y="row.names")
		rownames(anov) <-  anov$accession
		anov$accession <- NULL
		anov$descr <- NULL
		anov$Row.names <- NULL
		return (anov)
	}

	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.get.compar",sep=""))
	}
}




