

mcq.get.dataframe <- function (object, comp=FALSE,good.model=0.01) {
	if ((class(object) == "mcq.protquantity") || (class(object) == "mcq.peakcounting") || (class(object) == "mcq.spectralcounting")) {
		#if (is.null(object@metadata@metadata)) {
		if (nrow(object@metadata@metadata)==0) {
			tprot <- object@protval
		}
		else {
			tprot <- merge(object@protval, object@metadata@metadata, by.x="msrun", by.y="row.names")
		}

		if ((class(object) == "mcq.peakcounting")|| (class(object) == "mcq.spectralcounting")) {
			#rename q to count :
			colnames(tprot)[colnames(tprot) == "q"] <- "count"
		}

		return (tprot)
	}
	else if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {
		if (nrow(object@metadata@metadata)==0) {
			return (object@peptides)
		}
		else {
			tpep <- merge(object@peptides, object@metadata@metadata, by.x="msrun", by.y="row.names")
			return (tpep)
		}
	}
	else if (priv.mcq.is.anova.object(object)) {

		tprotanova <- merge(object@protval, object@metadata@metadata, by.x="msrun", by.y="row.names")
		tprotanova <- merge(tprotanova, object@proteins, by.x="protein", by.y="row.names")

		if (nrow(object@resultanov)!=0) {
			anov <- object@resultanov
			factorNameList <- c(object@paramlist$factorList,object@paramlist$interactionList)
			## proba.good.model in glm => Valid or Not valid
			if ((length(colnames(anov))-length(factorNameList)) >0) {
				anov$proba.good.model[which(anov$proba.good.model>=good.model)]="Valid"
				anov$proba.good.model[which(anov$proba.good.model<good.model)]="Not valid"
				colnames(anov)[1]="model"
				if(length(which(anov$model=="Not valid"))>0){cat("WARNING : There is Not valid models in your tab, verify your individuals data quality\n")}
			}
			colnames(anov)[(length(colnames(anov))-length(factorNameList)+1):length(colnames(anov))]<- paste("pval_", colnames(anov)[(length(colnames(anov))-length(factorNameList)+1):length(colnames(anov))], sep="")
			for (factorName in factorNameList) {
				anov[,length(anov)+1] <- p.adjust(object@resultanov[,factorName],method="BH")
				colnames(anov)[length(anov)]=paste("padj_",factorName,sep="")
			}
			tprotanova <- merge(tprotanova,anov, by.x="protein", by.y="row.names")
			
		}
		return (tprotanova)

	} else if (priv.mcq.is.pca.object(object)) {
		if(comp) {
			#write component table
			return (privGetMcqPCADudiComponent(object))
		}
		else {
			return (privGetMcqPCADudi(object))
		}
	} else if (class(object) == "mcq.protlist") {
		n <- length(object@proteins)
		df = data.frame(accession=names(object@proteins), descr=object@proteins ,
				stringsAsFactors=FALSE)
		return (df)
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.get.dataframe",sep=""))
	}
}


