
mcq.get.merge <- function (protquant.object,decision.stat.object, flist=NULL, na.rm=TRUE, sampleid=TRUE) {
	#priv.mcq.is.protquant.object is in "mcq_compute_protein_value.R" file
	if (priv.mcq.is.protquant.object(protquant.object)) {
		df1 <-mcq.get.compar(protquant.object, flist, na.rm, sampleid=sampleid)
	} else if (class(protquant.object)=="data.frame"){
		df1 = protquant.object
	} else {
		stop(paste("the class \"", class(protquant.object),"\" is not taken into account by mcq.get.merge",sep=""))
	}
	#priv.mcq.is.anova.object is in "mcq_anova.R" file
	if (priv.mcq.is.anova.object(decision.stat.object)) {
		df2 <-mcq.get.compar(decision.stat.object, flist, na.rm, sampleid=sampleid)
	} else if (class(decision.stat.object)=="data.frame"){
		df2 = decision.stat.object
	} else {
		stop(paste("the class \"", class(decision.stat.object),"\" is not taken into account by mcq.get.merge",sep=""))
	}
	#can we make a merge if object1 and object2 has different row numbers ? yes
	#can we make merge if object1 and object2 has different row names ? yes all lines will be reported with NA if they are absent from one of the two objects

	df <- merge(df1,df2,by=0,all=TRUE)
	rownames(df)=df$Row.names
	colnames(df)[1]=""
	return(df)
}

