
mcq.get.ratio <- function (object, sample1=NULL, sample2=NULL) {
	if (class(object) == "mcq.pairwise.t.test") {
		if (is.null(sample1)||is.null(sample2)) {
			stop(cat("There is one or two sample(s) missing : please define your arguments."))
		}
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.get.ratio",sep=""))
	}

	pairstr <- paste(sample1, sample2, sep=pkg.env$mcqr_separator_string)

	protlist = unique(object@restest$pair.result[object@restest$pair.result$pairs == pairstr,"proteins"])

	inv = F
	if (length(protlist) == 0) {
		inv = T
		pairstr <- paste(sample2, sample1, sep=pkg.env$mcqr_separator_string)


		protlist = unique(object@restest$pair.result[object@restest$pair.result$pairs == pairstr,"proteins"])
	}
	if (length(protlist) == 0) {
		stop(paste("There is no pair defined for the 2 sample names", paste(sample1, sample2,collapse=" "), ": please check your sample names.",sep=" "))
	}

	df <- data.frame(protein = protlist)
	rownames(df) <- df$protein
	df$ratio <- c(rep(NA,length(protlist)))
	df$ratiolog10 <- df$ratio
	df$sderror <- df$ratio
	df$pval <- df$ratio
	df$padj <- df$ratio

	#protein names :
	dfpairresult = merge(object@restest$pair.result, object@proteins, by.x="proteins", by.y="row.names")
	rownames(dfpairresult) = rownames(object@restest$pair.result)

	for (myprot in protlist) {
		pairid <- paste(myprot, pairstr, sep="__")
		short.tab <- dfpairresult[pairid,]
		#if (!is.na(short.tab[pairid, "ratio"])) {

		df[myprot, "accession"] <- short.tab[pairid, "accession"]
		#df[myprot, "ratio"] <- 10^tukey[[object@paramlist$factorListTuckey[[1]]]]
		df[myprot, "ratiolog10"] <- log10(short.tab[pairid, "ratio"])
		df[myprot, "ratio"] <- short.tab[pairid, "ratio"]
		df[myprot, "sderror"] <- short.tab[pairid, "sderror"]* log2(10)
		df[myprot, "pval"] <- short.tab[pairid, "pval"]
		df[myprot, "padj"] <- short.tab[pairid, "padjust"]
		#}
	}

	if (inv) {
		df$ratio = 1 / df$ratio
		df$ratiolog10 <- log10(df$ratio)
	}
	return (df)
}
