############## Imputation
# Replace missing data of peptides using their correlation with other peptides of the same protein.
# ATTENTION, dangerous, if we have authorized a lot of missing data. in standard, we authorized 5%, therefore here the number of missing data does not exceed 1 or 2 by peptide.

# The imputation will allow at the next step to not pay attention to missing data problem when we will reconstitue the protein value from the sum or the mean of peptides.

# After this step, it could still remain missing data : it is the case when all peptides of one protein are missing in a sampleAprès cette étape il peut encore rester quelques données manquantes : cas où tous les peptides d'une protéine sont absents dans un échantillon.

mcq.impute = function (object) {
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {
		if("lognorm" %in% colnames(object@peptides)) {

		}else {
			stop("mcqProtPep object is not normalized")
		}
		proteines <- unique(object@proteins$protein)

		tabok <- object@peptides
		tabok <- merge(tabok, object@metadata@metadata, by.x="msrun", by.y="row.names")
		tabok.nona=NULL
		for (i in 1:length(proteines)){
			tryCatch({
				getpep <- object@proteins[object@proteins$protein == proteines[i],"peptide"]
				print(i)
				sub=tabok[tabok$peptide %in% getpep,]
				toto=as.data.frame(tapply(sub$lognorm,list(sub$msrun,sub$peptiz),FUN=mean,na.rm=T))
				msrun=rep(rownames(toto),length(colnames(toto)))
				if (sum(is.na(toto))>0) {
					toto=irmi(toto)
				}
				toto=cbind(msrun,stack(toto))
				tabok.nona=rbind(tabok.nona,toto)
			}, error=function(e){cat("ERROR FOR protein ", proteines[i], " :",conditionMessage(e), "\n")})
		}
		
		
		colnames(tabok.nona)[2:3]=c("lognorm","peptiz")

		protein.data <- merge(unique(object@proteins[,c("peptide","protein","accession","protein_description")]),unique(object@peptides[,c("peptide","peptiz")]), by="peptide" )

		tabok.nona=merge(tabok.nona,protein.data,by="peptiz")
		tabok.nona=na.omit(tabok.nona)
		

# Calculation of number of proteins for which there remain a missing data because all peptides are absent of one sample.
		compte.prot=table(tabok.nona$protein,tabok.nona$msrun)
		bad=compte.prot==0
		bad.prot=apply(bad,1,sum)
		n.dmq=bad.prot[bad.prot>0]
		cat(paste("Number of proteins totally missing in at least one sample :" , length(n.dmq),"\n"))

		object@nona <- tabok.nona

		return (object)

	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.impute",sep=""))
	}
}


