

mcq.pairwise.t.test = function (object, factor) {
	if (priv.mcq.is.protquant.object(object)) {

		newObject <- new ("mcq.pairwise.t.test", protval =  object@protval , metadata =  object@metadata, proteins = object@proteins,
				samples = object@samples, paramlist= list(),restest = list())

		newObject@paramlist$factor <- factor

		protlist <- unique(newObject@protval$protein)
		allprot <- newObject@protval[,c("msrun", "protein", "q")]
		allprot <- merge (allprot, newObject@metadata@metadata, by.x="msrun", by.y="row.names")

		nmodal <- length(unique(object@metadata@metadata[,factor]))

		secondl <- 1
		pairwisestr = c(rep("",1))
		i <- 0
		flist <- unique(object@metadata@metadata[,factor])
		for (ione in 1:(nmodal-1)){
			secondl <- secondl+1
			for (itwo in secondl:nmodal){
				i <- i+1
				#pairwisestr[i] <- paste(flist[ione], flist[itwo], sep="--")
				pairwisestr[i] <- paste(flist[ione], flist[itwo], sep=pkg.env$mcqr_separator_string)
			}
		}
		ncomparisons <- length(pairwisestr)
		#print (pairwisestr)
		pval <- c(rep(NA, (ncomparisons *  length(protlist)) ))

		#names(pval) <- apply(expand.grid(protlist,pairwisestr),1,function(x) paste(x,collapse="__"))

		pair.result <- data.frame(ratio=pval, pval=pval, sderror=pval, proteins=rep(protlist, each=ncomparisons), pairs=rep(pairwisestr, length(protlist)))

		#rownames(pair.result) <- names(pval)
		rownames (pair.result) <- paste(pair.result$proteins,pair.result$pairs,sep="__")

		#print (pair.result)

		#print (names(newObject@restest$pval))
		#resultaov <- list()

		for (protid in protlist) {
			#print(paste("protid: ", protid, "\n"))
			short.tab <- pair.result[pair.result$proteins == protid,]
			oneprot <- allprot[allprot$protein == protid,]
			if (length(unique(oneprot[,factor])) < 2) {
				#not enough levels to compute contrast on this protein
				#continue
			}
			else {
				#oneprot[, factor] <- as.factor(oneprot[, factor])
				test <- pairwise.t.test(oneprot$q, oneprot[,factor], p.adjust.method = "none",pool.sd = T, alternative = "two.sided")
				#print(paste("ttest done\n"))
				#resultaov[protid] <- list(aov(as.formula(paste("q~",factor,sep="")), data=oneprot))
				lm.summary <- summary(lm(as.formula(paste("q~",factor,sep="")), data=oneprot))
				#res2 <- summary(lm(Y~X))
				#res2$sigma
				#print(paste("lm(as.formula(paste done\n"))

				aggdata <-aggregate(oneprot$q, by=list(oneprot[,factor]),	FUN=mean, na.rm=TRUE)

				#print (aggdata)

				count = table(oneprot[,factor], useNA = "no")

				#print (names(count)[2])

				#residual <- sqrt(anova(resultaov[[protid]])$"Mean Sq"[2])
				residual <- lm.summary$sigma


				for (pair in short.tab[,"pairs"]) {

					#print (pair)

					#level.one <- strsplit(pair, "--")[[1]][1]
					level.one <- strsplit(pair, pkg.env$mcqr_separator_string, fixed = TRUE)[[1]][1]
					#level.one <- substr(pair,1,regexpr(pkg.env$mcqr_separator_string,pair)-2)

					#print (level.one)
					#level.two <- strsplit(pair, "--")[[1]][2]
					level.two <- strsplit(pair, pkg.env$mcqr_separator_string, fixed = TRUE)[[1]][2]
					#level.two <- substr(pair,regexpr(pkg.env$mcqr_separator_string,pair)+3,nchar(pair))

					multiple <- sqrt((1/count[level.one]) + (1/count[level.two]))

					#print (test$p.value)
					#print (level.two)
					rowid = paste(protid, pair,sep="__")
					#print (rowid)
					if ((level.two %in% rownames(test$p.value)) && (level.one %in% colnames(test$p.value))) {
						pair.result[rowid, "pval"] <- test$p.value[ level.two, level.one]
						if (is.na(pair.result[rowid, "pval"])) {
							if ((level.one %in% rownames(test$p.value)) && (level.two %in% colnames(test$p.value))) {
								pair.result[rowid, "pval"] <- test$p.value[ level.one, level.two]
							}
						}
						pair.result[rowid, "sderror"] <- residual * multiple
						pair.result[rowid, "ratio"] <- (10^aggdata[aggdata$Group.1 == level.one, "x"])/(10^aggdata[aggdata$Group.1 == level.two, "x"])
					}
					else if ((level.one %in% rownames(test$p.value)) && (level.two %in% colnames(test$p.value))) {
						pair.result[rowid, "pval"] <- test$p.value[ level.one, level.two]
						if (is.na(pair.result[rowid, "pval"])) {
							if ((level.two %in% rownames(test$p.value)) && (level.one %in% colnames(test$p.value))) {
								pair.result[rowid, "pval"] <- test$p.value[ level.two, level.one]
							}
						}
						pair.result[rowid, "sderror"] <- residual * multiple
						pair.result[rowid, "ratio"] <- (10^aggdata[aggdata$Group.1 == level.one, "x"])/(10^aggdata[aggdata$Group.1 == level.two, "x"])
					}
				}
			}
			#print (test)
		}

		print ("padjust")
		pair.result$padjust <- p.adjust(pair.result$pval,method="fdr")


		newObject@restest$pair.result <- pair.result
		#newObject@restest$listaov <- resultaov
		return (newObject)
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.pairwise.t.test",sep=""))
	}
}


