mcq.pca = function (object, flist=NULL) {
	if (length(colnames(object@metadata@metadata)) == 0) {
		stop("Metadata are required")
	}

	if  ((priv.mcq.is.peptidequant.object(object)) || (priv.mcq.is.protquant.object (object))) {
		if (priv.mcq.is.protquant.object (object)) {
			tsamples = object@samples
			tp=object@proteins
			rownames(tp) <- tp$accession
		} else {
			tsamples = unique(object@peptides[,c("msrun","msrunfile")])
			rownames(tsamples) <- tsamples$msrun
			tsamples$msrun <- NULL
			tp <- unique(object@peptides[, c("peptide","peptiz")])
			tp$peptide <- as.character(tp$peptide) 
			tp$peptiz <- as.character(tp$peptiz) 
			rownames(tp)=tp$peptiz
		}
		
		tacp= mcq.get.compar(object, flist)
		tacp <- na.omit(tacp)
		
		# cleaning dataframes after na.omit
		pList <- rownames(tacp)	
		
		if (length(rownames(tacp)) < 3) {
			stop(paste("Too few variables (",length(rownames(tacp)),") to perform PCA", sep=""))
		}
		if (length(colnames(tacp)) < 3) {
			stop(paste("Too few individuals (",length(colnames(tacp)),") to perform PCA", sep=""))
		}
		
		acpnf <- length(colnames(tacp))-1
		if (acpnf > 5) {
			acpnf <- 5
		}
		
		tp <- tp[rownames(tp) %in% pList,]
						
		if (priv.mcq.is.protquant.object (object))  {
			newObject <- new ("mcq.class.prot.pca", tag=tp, metadata = object@metadata, samples = tsamples, pca = list())
			newObject@pca$dudi <- dudi.pca(t(tacp),center = TRUE, scale = TRUE, scannf = FALSE, nf = acpnf) 
			newObject@pca$factorList <- flist
			newObject@pca$nf <- acpnf
			newObject@pca$qname <- "q"
		}
		else {
			newObject <- new ("mcq.class.peptide.pca", tag=tp, metadata = object@metadata, samples = tsamples, pca = list())
			newObject@pca$dudi <- dudi.pca(t(tacp),center = TRUE, scale = TRUE, scannf = FALSE, nf = acpnf) 
			newObject@pca$factorList <- flist
			newObject@pca$nf <- acpnf
			if (is.null(object@peptides$lognorm)) {
				newObject@pca$qname <- "logarea"
			}else{
				newObject@pca$qname <- "lognorm"
			}
		}

		return (newObject)
		
} else {
		stop(paste("the class \"", class(mcq),"\" is not taken into account by mcq.pca",sep=""))
	}
}

