

mcq.peak.counting = function(object) {
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {

		tab<- merge(object@peptides[,c("peptide", "msrun")], object@proteins, by="peptide")

		tquant <- as.data.frame(table(tab$protein, tab$msrun))
		colnames(tquant)<-c("protein", "msrun", "q")
		tquant$protein=as.character(tquant$protein)
		tquant$msrun=as.character(tquant$msrun)

		tprot=unique(object@proteins[,c("protein","accession", "protein_description")])
		rownames(tprot) <- tprot$protein
		tprot$protein <- NULL
		colnames(tprot)[colnames(tprot) == "protein_description"] <- "descr"

		tsamples = unique(object@peptides[,c("msrun","msrunfile")])
		rownames(tsamples) <- tsamples$msrun
		tsamples$msrun <- NULL

# creation of the mcq.peakcounting object
		mcqCount <- new ("mcq.peakcounting", metadata = object@metadata, protval=tquant, proteins= tprot, samples= tsamples)
		return(mcqCount)

	}else{
		stop("Input is not a mcqProtPep or a mcq.skyline object")
	}
	return (NULL)
}





