
mcq.plot.Tukey <- function (object,  file = NULL, protlist=NULL) {
	if (priv.mcq.is.anova.object(object)) {
		if (is.null(object@resultanov)) {
			stop("there is no anova results in your object")
		}
		if (is.null(object@resulttukey)) {
			stop("there is no Tukey results in your object")
		}
	}else{
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.plot.proteins",sep=""))
	}
	
	if (is.null(protlist)) {
		protlist <- mcq.get.protlist(object)
	}
	
	if (is.null(file)){
		par(ask=TRUE)
	}
	else{
		pdf(file, title=gsub('.pdf$','',file))
	}

	cc <- c("red","green4","blue","cyan","wheat1","magenta","yellow","gray","darkorange", "brown", "purple", "yellowgreen","turquoise",  "antiquewhite2", "aquamarine",  "aquamarine4",  "chartreuse3", "chocolate" , "coral", "darkred", "darksalmon",  "darkseagreen1","darkslateblue",  "darkslategray1","darkturquoise" , "darkviolet" , "deeppink", "deeppink4", "goldenrod3", "goldenrod4","burlywood3", "lightgreen")
	palette(cc)
	dev.off() # because palette(cc) open a device !
	for (accession in names(protlist@proteins)) {
		title <- accession
		par(mar=c(5,4,0,2)+0.1)
		par(oma=c(1,1,7,1))
		prot=rownames(object@proteins)[which(object@proteins$accession==accession)]
		plot(cld(object@resulttukey[[prot]]),col=cc) 
		mtext(title,side=3, line=5.0, adj=0.5, cex=1.6,outer=TRUE)
	}
	if (!is.null(file)){
		dev.off()
	}

}
