
mcq.plot.intensity.correlation<- function (object, refSample=refSample, file=NULL) {
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {
		if (refSample %in% object@peptides$msrun) {
		}
		else {
			stop(paste("The sample ",refSample," is not in the input object of class ",class(object), sep=""))
		}

		nomref=refSample
		tab.acp<- tapply (object@peptides$logarea, list(object@peptides$peptiz,object@peptides$msrun), FUN=sum)

		ref=which(colnames(tab.acp)==nomref) 
		nbech=dim(tab.acp)[2] 

		if (is.null(file)){
			par(ask=FALSE)
		}
		else{
			pdf(file, title=gsub('.pdf$','',file))
		}
		par(mfrow=c(2,2))
		for (i in 1:nbech) {
			if (i !=ref ) {
				test=cor.test(tab.acp[,ref], tab.acp[,i])
				plot(tab.acp[,c(ref,i)], pch=19, xlab=paste("Log-intensity in ", refSample, sep=""), ylab=paste("Log-intensity in ", colnames(tab.acp)[i], sep=""), cex=0.4, main=c("Correlation of log-intensities ", paste("between ", refSample, " and ",colnames(tab.acp)[i], sep="" )), cex.main=0.8, cex.axis=0.8, cex.lab=0.8)
				legend("bottomright", legend=paste("r = ", round(test$estimate, 2), sep=""), cex=0.8, bty="n")
				abline(a=0, b=1, col="red")
				if (is.null(file)){
					par(ask=TRUE)
				}
			}
		}
		if (!is.null(file)){
			dev.off()
		}
		par(mfrow=c(1,1))
	}
	else {
		stop(paste("The class \"", class(object),"\" of the input object is not taken into account by the function mcq.plot.intensity.correlation",sep=""))
	}
}


