
mcq.plot.intensity.differences<- function (object, refSample=refSample, nclass=100, file=NULL) {
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {
		if (refSample %in% object@peptides$msrun) {

		}
		else {
			stop(paste("The sample ",refSample," is not in the input object of class ",class(object), sep=""))
		}
		nomref=refSample 
		tab.acp<- tapply (object@peptides$logarea, list(object@peptides$peptiz,object@peptides$msrun), FUN=sum)

		ref=which(colnames(tab.acp)==nomref) 
		nbech=dim(tab.acp)[2] 
		nbpep=dim(tab.acp)[1] 
		matref=matrix(rep(tab.acp[,ref],nbech),ncol=nbech)
		diff=tab.acp-matref

		if (is.null(file)){
			par(ask=FALSE)
		}
		else{
			pdf(file, title=gsub('.pdf$','',file))
		}
		par(mfrow=c(2,2))
		for (i in 1:nbech) {
			if (i !=ref ) {
				hist(diff[,i], nclass=nclass, main=c("Distribution of the intensity differences", paste("between ", colnames(tab.acp)[i]," and ",refSample, sep="")), xlab=paste("(Log-intensity in ",colnames(tab.acp)[i], ") - (Log-intensity in ", refSample, ")", sep="" ), xlim=c(-2,2), cex.main=0.8, cex.axis=0.8, cex.lab=0.8)
				if (is.null(file)){
					par(ask=TRUE)
				}
			}
		}
		if (!is.null(file)){
			dev.off()
		}
		par(mfrow=c(1,1))
	}
	else {
		stop(paste("The class \"", class(object),"\" of the input object is not taken into account by the function mcq.plot.intensity.differences.",sep=""))
	}
}

