
mcq.plot.pairwise.t.test = function (object,pdf=NULL) {

	tabprot <- object@protval
	listprot <- unique(object@protval$protein)
	factorName <- object@paramlist$factor

	cat(paste("The factor \"", factorName,"\" was used to select proteins significantly different\n", sep=""))

	cat(paste(length(listprot)," proteins significantly different between extrem levels of factor \"",factorName,  "\"\n", sep=""))

	if (is.null(pdf)){
		par(ask=TRUE)
	}
	else{
		pdf(pdf, title=gsub('.pdf$','',pdf))
	}

	tabprot <- merge(object@protval, object@metadata@metadata, by.x="msrun", by.y="row.names")

	for (protein_code in listprot) {
		tabcour=tabprot[tabprot$protein==protein_code,]
		protein_name <- object@proteins[protein_code, "accession"]
		if (is.na(protein_name)) {
			protein_name <- protein_code
		}
		title <- paste(protein_name, " (", factorName, ")", sep="")
		visuprot(protein_code,tabcour,tabcour$q,tabcour[,factorName], title=title)
	}



	if (!is.null(pdf)){
		dev.off()
	}

}
