
mcq.plot.peak.width <- function (object, file=NULL, limit=NULL, nclass=40) {
	if (class(object) == "mcqProtPep") {
		width_peak <- object@peptides[,'rtend'] - object@peptides[,'rtbegin']
	}else {
		if (class(object) != "mcqData") {
			stop("Input is not a mcqData or a mcqProtPep object")
		}
		if (nrow(object@quantipeptides)[[1]] == 0) {
			stop("No quantification results")
		}
		width_peak <- object@quantipeptides[,'rt_end'] - object@quantipeptides[,'rt_begin']
	}

	if (!is.null(file)){
		pdf(file, title=gsub('.pdf$','',file))
	}
	if (is.null(limit)) {
				hist(width_peak,main="Distribution of peak width",xlab="Width of chromatographic peaks (seconds)", nclass=nclass, border="darkblue")
	}else {
		hist(width_peak,main="Distribution of peak width",xlab="Width of chromatographic peaks (seconds)", nclass=nclass, border="darkblue", xlim = c(0,limit))
	}
	mtext(paste("Quantiles: 10% = ", round(quantile(width_peak, 0.1), 1),"; 25% = ",round(summary(width_peak)[2], 1),"; 50% = ",round(summary(width_peak)[3], 1),"; 75% = ", round(summary(width_peak)[5], 1),"; 90% = ", round(quantile(width_peak, 0.9), 1), sep=""),side=3)
	if (!is.null(file)){
		dev.off()
	}

}
