
mcq.plot.protquantity = function (object, factorName, proteinList ,file=NULL) {
	if (!priv.mcq.is.protquant.object(object)) {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.plot.protquantity",sep=""))
	}

	tabprot <- object@protval

	if (is.null(proteinList)) {
		proteinList <- mcq.get.protlist(object)
	}

	if (is.null(file)){
		par(ask=TRUE)
	}
	else{
		pdf(file, title=gsub('.pdf$','',file))
	}

	tabprot <- merge(object@protval, object@metadata@metadata, by.x="msrun", by.y="row.names")

	for (protein_code in names(proteinList@proteins)) {
		tabcour=tabprot[tabprot$protein==protein_code,]
		protein_name <- object@proteins[protein_code, "accession"]
		if (is.na(protein_name)) {
			protein_name <- protein_code
		}
		title <- paste(protein_name, " (", factorName, ")", sep="")
		visuprot(protein_code,tabcour,tabcour$q,tabcour[,factorName], title=title)
	}



	if (!is.null(file)){
		dev.off()
	}

}

