
mcq.plot.pvalues <- function (object, file = NULL, nclass=100) {
	if (priv.mcq.is.anova.object(object) || (class(object)=="mcq.pairwise.t.test")) {

	}
	else {
		stop(paste("The object ",class(object)," is not taken into account by mcq.plot.pvalue"))
	}

	if (is.null(file)){
		par(ask=FALSE)
	}
	else{
		pdf(file, title=gsub('.pdf$','',file))
	}
	if (priv.mcq.is.anova.object(object)) {
		for (i in 1:length(object@paramlist$factorList)){
			factor=object@paramlist$factorList[i]
			tpval <- object@resultanov[,factor]
			hist(tpval,main=paste("Distribution of p-values for factor \"", factor,"\"", sep=""), xlab=" p-values", nclass=nclass)
		}
	}
	else if (class(object)=="mcq.pairwise.t.test") {
		tpval <- object@restest$pair.result$pval
		hist(tpval,main=paste("Distribution of p-values for factor \"", object@paramlist$factor,"\"", sep=""), xlab="p-values", nclass=nclass)
	}
	if (!is.null(file)){
		dev.off()
	}
}

