
mcq.protquantity = function (object, method="sum") {
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {
		aggregate.function <- "sum"
		if (method == "mean") {
			aggregate.function <- "mean"
		} else if (method == "sum") {
		}
		else {
			stop(paste("unknown method ",method," for mcq.protquantity function on \"", class(object),"\" object.",sep=""))
		}
		cat(paste("compute protein quantities with the ",aggregate.function," of peptide intensities\n",sep=""))
		if("lognorm" %in% colnames(object@nona)) {
			##### construction of protein value by sum of peptides.
# As missing data have been replaced, the sums are done on the same peptides in all samples.
# The sums are on the areas and not on the logs.
			tprot=aggregate(10^object@nona$lognorm,list(object@nona$protein,object@nona$msrun),FUN=aggregate.function, na.rm=TRUE)

		}else {
			warning(paste("no imputations in \"", class(object),"\" object",sep=""))
			if("areanorm" %in% colnames(object@peptides)) {
				table <- merge(object@peptides[, c("peptide", "msrun","areanorm","lognorm")], object@proteins[, c("peptide", "protein")], by="peptide")
				tprot=aggregate(10^table$lognorm,list(table$protein,table$msrun),FUN=aggregate.function, na.rm=TRUE)
			} else {
				warning(paste("data are not normalized in \"", class(object),"\" object",sep=""))
				table <- merge(object@peptides[, c("peptide", "msrun","area","logarea")], object@proteins[, c("peptide", "protein")], by="peptide")
				tprot=aggregate(10^table$logarea,list(table$protein,table$msrun),FUN=aggregate.function, na.rm=TRUE)
			}
		}

		colnames(tprot)=c("protein","msrun","q")
		tprot$q=log10(tprot$q)
#Recuperation of the descriptor
		prot.prot=unique(object@proteins[,c("protein","accession", "protein_description")])
		rownames(prot.prot) <- prot.prot$protein
		prot.prot$protein <- NULL

		tsamples = unique(object@peptides[,c("msrun","msrunfile")])
		rownames(tsamples) <- tsamples$msrun
		tsamples$msrun <- NULL


		#rename protein_description :
		colnames(prot.prot)[colnames(prot.prot) == "protein_description"] <- "descr"


		return (new ("mcq.protquantity", metadata = object@metadata	, proteins = prot.prot, protval = tprot, samples = tsamples))

	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.protquantity",sep=""))
	}
}
