

mcq.read.spectralcounting = function(comparspectraFile) {

# Looking for hashtag which impede the correct reading of comparspectraFile
	con <- file(comparspectraFile, 'r') 
	notempty = TRUE
	line = 0
	while (notempty){ 
		current_line = readLines(con, n=1)
		line = line+1
   		hashtag_pos = grep("#", current_line)
   		if(length(grep("#", current_line))>0){
			stop(paste("hashtag detected in line ", line, ". Please remove hashtags from ",comparspectraFile, " to ensure correct reading.", sep=""))
		}
 		if (length(current_line) >0){
			notempty = TRUE
		}else{
			notempty = FALSE
		}
	} 
	close(con)

	scounting = read.table(comparspectraFile,header=TRUE,sep="\t",check.names=FALSE, dec=".", allowEscapes = FALSE, quote="", stringsAsFactors=FALSE)
	scounting=scounting[,-ncol(scounting)]

# Parsing accession number
	scounting[,"Top Protein Description"] <- str_trim(scounting[,"Top Protein Description"])
	scounting$protein <- word(scounting[,"Top Protein Description"])


# Get protein description
	prot.prot=unique(scounting[,c("protein", "Top Protein Description")])
	prot.prot$accession <- prot.prot$protein
	rownames(prot.prot) <- prot.prot$protein
	prot.prot$protein <- NULL

#Rename protein_description :
	colnames(prot.prot)[colnames(prot.prot) == "Top Protein Description"] <- "descr"
	samples=colnames(scounting)[7:length(scounting)-1]
	scounting=melt(scounting, id.vars = "protein", measure.vars = samples)
	colnames(scounting)=c("protein","msrunfile","q")


#Get samples information
	tsamples=data.frame(msrunfile=unique(scounting[,2]))

	mcqCount <- new ("mcq.spectralcounting", protval=scounting, proteins= prot.prot, samples= tsamples)
	return(mcqCount)

}


