
mcq.select.protlist <- function(object, protlist=protlist) {
	if (class(object) == "mcq.protlist") {
		object@proteins <- object@proteins[names(object@proteins) %in% names(protlist@proteins)]
		return (object)
	}
	else if (priv.mcq.is.protquant.object(object)) {
		#metadata = object@metadata	, proteins = prot.prot, protval = tprot, samples = tsamples

		object@proteins <- object@proteins[object@proteins$accession %in% names(protlist@proteins) ,]
		#object@proteins <- drop.levels(object@proteins)

		object@protval <- object@protval[object@protval$protein %in% rownames(object@proteins) ,]
		#object@protval <- drop.levels(object@protval)


		object@samples$bidonnage <- rownames(object@samples)
		object@samples <- object@samples[unique(object@protval$msrun) ,]
		object@samples$bidonnage <- NULL
		#object@samples <- drop.levels(object@samples)


		object@metadata@metadata$bidonnage <- rownames(object@metadata@metadata)
		object@metadata@metadata <- object@metadata@metadata[rownames(object@samples) ,]
		object@metadata@metadata$bidonnage <- NULL
		#object@metadata@metadata <- drop.levels(object@metadata@metadata)


		return (object)
	}
	else if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {
		nbpeptides <- length(unique(object@peptides$peptide))
		nbprot <- length(unique(object@proteins$protein))

		object@proteins <- object@proteins[object@proteins$accession %in% names(protlist@proteins) ,]
		#object@proteins <- drop.levels(object@proteins)

		object@peptides <- object@peptides[object@peptides$peptide %in% object@proteins$peptide,]
		#object@peptides <- drop.levels(object@peptides)


		if (nrow(object@metadata@metadata) > 0){

			cat (paste("cleaning metadata\n", sep=""))
			object@metadata@metadata$bidonnage <- rownames(object@metadata@metadata)
			object@metadata@metadata <- object@metadata@metadata[unique(object@peptides$msrun),]
			object@metadata@metadata$bidonnage <- NULL
			#object@metadata@metadata <- drop.levels(object@metadata@metadata)

			cat (paste("cleaning metadata samples\n", sep=""))
			object@metadata@samples$bidon <- rownames(object@metadata@samples)
			object@metadata@samples <- object@metadata@samples[rownames(object@metadata@metadata),]
			object@metadata@samples$bidon <- NULL
			#object@metadata@samples <- drop.levels(object@metadata@samples)
		}

		nbpeptidesafter <- length(unique(object@peptides$peptide))
		nbprotafter <- length(unique(object@proteins$protein))
		cat (paste((nbpeptides - nbpeptidesafter), " peptides dropped\n", sep=""))
		cat (paste((nbprot - nbprotafter), " proteins dropped\n", sep=""))

		cat (paste( length(unique(object@peptides$peptiz)), " peptiz left\n", sep=""))
		cat (paste((nbpeptidesafter), " peptides left\n", sep=""))
		cat (paste((nbprotafter), " proteins left\n", sep=""))
		return (object)
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.select.protlist",sep=""))
	}
}
