\name{mcq.drop}

\alias{mcq.drop}

\title{Drop Undesired Levels}

\description{This function removes the data related to one or several levels within a given factor.}

\usage{mcq.drop(object, factor="", levels="")}

\arguments{
  \item{object}{an object of class 'mcqProtPep', 'mcq.spectralcounting', 'mcq.peakcounting' or 'mcq.protquantity'}
  \item{factor}{a character vector indicating the factor containing the level(s) to drop}
  \item{levels}{a character vector indicating the level(s) to drop }
}

\details{This function allows to remove samples, peptides or proteins from the proteomic dataset}

\value{The function 'mcq.drop' returns the input object without the undesired level(s). }

\references{}

\author{}

\note{}

\seealso{}

\examples{
# Preliminary step: load the example dataset and merge metadata to the object of class 'mcqProtPep'
	data(extraction)
	protPep <- mcq.merge.metadata(protPep, metadata.info)
	summary(protPep)
	
# Remove individual samples from the input object
	protPep.cleaned <- mcq.drop(protPep, factor="msrun", levels=c("samp0", "samp1"))
	summary(protPep.cleaned)

# Remove a group of samples in the experimental design
	protPep.cleaned <- mcq.drop(protPep, factor="extraction", levels="teal")
	summary(protPep.cleaned)

# Remove peptides from the input object
	protPep.cleaned <- mcq.drop(protPep, factor="peptide", levels="pepa1a1")
	summary(protPep.cleaned)

# Remove proteins from the input object
	protPep.cleaned <- mcq.drop(protPep, factor="protein", levels=c("a1.a1.a1","a1.a2.a1"))
	summary(protPep.cleaned)
	protPep.cleaned <- mcq.drop(protPep, factor="accession", levels=c("GRMZM2G473001_P01", "GRMZM2G069542_P01"))
	summary(protPep.cleaned)

}


