\name{mcq.peak.counting}

\alias{mcq.peak.counting}

\title{Number of Peaks per Protein and Sample}

\description{This function computes the abundance of each protein as the number of chromatographic peaks attributed to each protein.}

\usage{mcq.peak.counting(object)}

\arguments{
\item{object}{an object of class 'mcqProtPep' or 'mcq.slyline'}
}

\details{A chromatographic peak is defined by a combination of a peptidic sequence with modifications and charge state. In the 'peptide' slot of the object of class 'mcqProtPep', such a combination is referred to as 'peptiz'.}

\value{
The function 'mcq.peak.counting' returns an object of class 'mcq.peakcounting' with four slots: proteins, metadata, protval and samples. The number of peaks per protein and sample is stored in the 'protval' slot.}

\references{}

\author{}

\note{}

\seealso{}

\examples{
# Load the example dataset
	data(extraction)

# Launch the 'mcq.peak.counting' function
	pkcount <- mcq.peak.counting(protPep)
}

\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
