\name{mcq.plot.counts.per.sample}

\alias{mcq.plot.counts.per.sample}

\title{Plot Counts}

\description{Depending on the class of the object used as input, this function plots either the total number of chromatographic peaks or the total number of spectra per sample.}

\usage{mcq.plot.counts.per.sample(object, file=NULL)}

\arguments{
    \item{object}{an object of class 'mcq.peakcounting' or 'mcq.spectralcounting'}
    \item{file}{a character vector indicating the name of the pdf file where to export the histogram (e.g. "mygraph.pdf"). By default, the graph is displayed on the screen} 
}

\details{Depending on the class of the object used as input, the function 'mcq.plot.counts.per.sample' plots either a numer of spectra or a number of chromatographic peaks. }

\value{The function 'mcq.plot.counts.per.sample' returns a graph that is displayed on the screen when the pdf argument is NULL or that is exported as a pdf file when the pdf argument is filled in.}

\references{}

\author{}

\note{}


\seealso{}

\examples{
# Preliminary step: load the example dataset and compute the protein abundances as the number of chromatographic peaks
	data(extraction)
	pkcount <- mcq.peak.counting(protPep)

# Launch the 'mcq.plot.peaks.per.sample' function
	mcq.plot.counts.per.sample(pkcount)
}
 
