\name{mcq.plot.intensity.correlation}

\alias{mcq.plot.intensity.correlation}

\title{Plot Intensities for Pairs of Samples}

\description{This function draws a graph showing the peak intensities of a given sample versus the peak intensities of a sample chosen as a reference.}

\usage{mcq.plot.intensity.correlation(object, refSample="", file=NULL)
}

\arguments{
	\item{object}{an object of class 'mcqProtPep' or 'mcq.skyline'}
	\item{refSample}{a character vector indicating the name of the msrun corresponding to the sample chosen as a reference. See the column 'msrun' in the metadata file}
	\item{file}{a character vector indicating the name of the pdf file where to export the histograms (e.g. "mygraph.pdf"). By default, the graphs are displayed on the screen}
}
\details{Log-transformed peak intensities are used for plotting. The coefficient of correlation is indicated on each graph. The first bisector is shown in red.}

\value{The function 'mcq.plot.intensity.correlation' returns a series of graphs that are displayed on the screen when the file argument is NULL or that are exported as a pdf file when the file argument is filled in. }

\references{}

\author{}

\note{}


\seealso{'cor', 'cor.test'}

\examples{
# Preliminary step: load the example dataset
	data(extraction)

# Launch the 'mcq.plot.intensity.correlation' function
	mcq.plot.intensity.correlation(protPep, refSample="samp0")

}


