\name{mcq.plot.intensity.differences}

\alias{mcq.plot.intensity.differences}

\title{Plot Histogram of Intensity Differences}

\description{This function draws a histogram for the distribution of intensity differences between a given sample and a sample chosen as reference.}

\usage{mcq.plot.intensity.differences(object, refSample="", nclass=100, file=NULL)
}

\arguments{
	\item{object}{an object of class 'mcqProtPep' or 'mcq.skyline'}
	\item{refSample}{a character vector indicating the name of the msrun corresponding to the sample chosen as a reference. See the column 'msrun' in the metadata file}
	\item{nclass}{an integer indicating the number of bars to be drawn. By default, it is set to 100}
	\item{file}{a character vector indicating the name of the pdf file where to export the histograms (e.g. "mygraph.pdf"). By default, the graphs are displayed on the screen}
}
\details{Intensity differences between two samples are computed on log-transformed chromatographic peak intensities.}

\value{The function 'mcq.plot.intensity.differences' returns a series of graphs that are displayed on the screen when the file argument is NULL or that are exported as a pdf file when the file argument is filled in.}

\references{}

\author{}

\note{}


\seealso{'hist'}

\examples{
# Preliminary step: load the example dataset
	data(extraction)

# Launch the 'mcq.plot.intensity.differences' function
	mcq.plot.intensity.differences(protPep, refSample="samp0")

# Change the refSample and the number of bars
	mcq.plot.intensity.differences(protPep, refSample="samp2", nclass=50)
}


