\name{mcq.plot.intensity.distribution}

\alias{mcq.plot.intensity.distribution}

\title{Plot Intensity Histograms}

\description{This function draws histogram for the distribution of intensities for each sample.}

\usage{mcq.plot.intensity.distribution(object, nclass=100, file=NULL)}


\arguments{
	\item{object}{an object of class 'mcqProtPep' or 'mcq.skyline'}
	\item{nclass}{an integer indicating the number of bars to be drawn. By default, it is set to 100}
	\item{file}{a character vector indicating the name of the pdf file where to export the histograms (e.g. "mygraph.pdf"). By default, the graphs are displayed on the screen}
}

\details{}

\value{The function 'mcq.plot.intensity.distribution' returns a series of graphs that are displayed on the screen when the file argument is NULL or that are exported as a pdf file when the file argument is filled in.}

\references{}

\author{}

\note{}


\seealso{'hist'}

\examples{
# Preliminary step: load the example dataset
	data(extraction)

# Launch the 'mcq.plot.intensity.distribution' function with default parameters
	mcq.plot.intensity.distribution(protPep)

# Change the number of bars
	mcq.plot.intensity.distribution(protPep, nclass=50)

}






