\name{mcq.plot.pca}

\alias{mcq.plot.pca}

\title{Plot Principal Component Analysis}

\description{This function plots the results of a principal component analysis through several graphs representing the position of the individuals on the plans defined by the first axes, the weights of the axes and the correlation circle.}

\usage{mcq.plot.pca(object, factorToColor=NULL, file=NULL, labels=NULL)}

\arguments{
  \item{object}{an object of class 'mcq.class.prot.pca' or 'mcq.class.peptide.pca'}
  \item{factorToColor}{a character vector indicating the factor or the combination of factors to color}
  \item{file}{a character vector indicating the name of the pdf file where to export the graphs (e.g. "mygraph.pdf"). By default, the graphs are displayed on the screen}
  \item{labels}{a character vector indicating the factor or the combination of factors whose levels will be used to label the individuals on the graphs. By default, labels are the names associated to the individuals in the input object. }
}

\details{}

\value{The function 'mcq.plot.pca' returns a series of graphs that are displayed on the screen when the file argument is NULL or that is exported as a pdf file when the file argument is filled in.}

\references{}

\author{}

\note{}

\seealso{}

\examples{
# Preliminary step: load the example dataset and merge metadata to the object of class 'mcqProtPep'
	data(extraction)
	protPep <- mcq.merge.metadata(protPep, metadata.info)

# Launch the 'mcq.plot.pca' function with default parameters
	mypca <- mcq.pca(protPep)
	mcq.plot.pca(mypca) 

# Change the color and the labels of the individuals 
	mcq.plot.pca(mypca, factorToColor=c("extraction"), labels=c("extraction", "rep")) 
}

