\name{mcq.plot.rt.variability}

\alias{mcq.plot.rt.variability}

\title{Plot Retention Time Variability}

\description{This function draws a histogram for the distribution of the standard deviation of peptides' retention time.}

\usage{mcq.plot.rt.variability(object, file=NULL, limit=NULL, nclass=100)}

\arguments{
\item{object}{an object of class 'mcqProtPep'}
\item{file}{a character vector indicating the name of the pdf file where to export the histogram (e.g. "mygraph.pdf"). By default, the graph is displayed on the screen}
\item{limit}{a numerical value indicating the upper bound of the x-axis}
\item{nclass}{an integer indicating the number of bars to be drawn}
}
\details{For each peptide in the object of class 'mcqProtPep', the standard deviation of retention time is computed from the values of retention time obtained in the samples where the peptide was quantified.}

\value{The function 'mcq.plot.rt.variability' returns a graph that is displayed on the screen when the file argument is NULL or that is exported as a pdf file when the file argument is filled in.}

\references{}

\author{}

\note{}

\seealso{'hist'}

\examples{
# Preliminary step: load the example dataset
	data(extraction)

# Launch the 'mcq.plot.peak.width' function with default parameters
	mcq.plot.rt.variability(protPep)

# Zoom on the peptides showing poor retention time variability
	mcq.plot.rt.variability(protPep, limit=5)
	mcq.plot.rt.variability(protPep, limit=5, nclass=500)
}

\keyword{ ~kwd1 }
\keyword{ ~kwd2 }
