
abundance.ratio.pairwise.t.test <- function (object, sample1, sample2) {

	pairstr <- paste(sample1, sample2, sep="--")
	#onlypair <- object@restest$pair.result[object@restest$pair.result$pairs == pairstr,"proteins"]

	protlist = unique(object@restest$pair.result[object@restest$pair.result$pairs == pairstr,"proteins"])

	#print (protlist)

	df <- data.frame(protein = protlist)
	rownames(df) <- df$protein
	df$ratio <- c(rep(NA,length(protlist)))
	df$sderror <- df$ratio
	df$pval <- df$ratio
	df$decision <- c(rep("NO",length(protlist)))
	df$padj <- df$ratio

	for (myprot in protlist) {
		pairid <- paste(myprot, pairstr, sep="__")
		#print (pairid)
		short.tab <- object@restest$pair.result[pairid,]
		#if (!is.na(short.tab[pairid, "ratio"])) {

			#df[myprot, "ratio"] <- 10^tukey[[object@paramlist$factorListTuckey[[1]]]]

			df[myprot, "ratio"] <- log2(short.tab[pairid, "ratio"])
			df[myprot, "sderror"] <- short.tab[pairid, "sderror"]* log2(10)
			df[myprot, "pval"] <- short.tab[pairid, "pval"]
			df[myprot, "padj"] <- short.tab[pairid, "padjust"]
			if (df[myprot, "padj"] <= 0.05) {
				df[myprot, "decision"] <- "YES"
			}
		#}
	}
	return (df)
}

abundance.ratio <- function (object, sample1, sample2) {
	df <- data.frame(protein = names(object@resulttukey))
	rownames(df) <- df$protein
	df$ratio <- c(rep(NA,length(object@resulttukey)))
	df$lwr <- df$ratio
	df$upr <- df$ratio
	df$padj <- df$ratio
	df$decision <- c(rep("NO",length(object@resulttukey)))

	for (myprot in names(object@resulttukey)) {
		#print (object@resulttukey[myprot])
		tukey <- object@resulttukey[[myprot]][[object@paramlist$factorListTuckey[[1]]]]
		print (tukey)
		#groups <- tukey$groups
		#print(groups)
		#print(groups[groups$trt==sample1, "means"])
		#print (tab[tab$trt == sample1, "means"])

		#ratio with agricolae Tukey :
		#df[myprot, "ratio"] <- log2((10^groups[groups$trt==sample1, "means"]) / (10^groups[groups$trt==sample2, "means"]))

		#df[myprot, "ratio"] <- 10^tukey[[object@paramlist$factorListTuckey[[1]]]]
		diffstr <- paste(sample1,sample2,sep='-')
		inv <- 1
		if (diffstr %in% rownames(tukey)) {
		} else {
			diffstr <- paste(sample2,sample1,sep='-')
			inv <- -1
		}
		df[myprot, "ratio"] <- (inv * (tukey[diffstr, "diff"]))* log2(10)
		df[myprot, "lwr"] <- (inv * (tukey[diffstr, "lwr"]))* log2(10)
		df[myprot, "upr"] <- (inv * (tukey[diffstr, "upr"]))* log2(10)
		df[myprot, "padj"] <- (tukey[diffstr, "p adj"])
		if (inv == -1) {
			temp <- df[myprot, "lwr"]
			df[myprot, "lwr"] <- df[myprot, "upr"]
			df[myprot, "upr"] <- temp
		}
		if (df[myprot, "padj"] <= 0.05) {
			df[myprot, "decision"] <- "YES"
		}
	}
	return (df)
}
