save(protPep, file="protPep.RData")
save(protPep, file="protPep_clean.RData")
save(protPepnona, file="protPep_clean.RData")
qprot <- mcq.protquantity(protPep)
mcqPlotProteinValueSd(qprot, pdf='SD_logQNorm.pdf')
head(qprot@protval)
	tacp <- mcq.get.compar(qprot, sampleid=F)
	head(tacp)

save(pkcount.mindiff, file="pkcount.RData")

load("pkcount.RData")


# Statistique décisionnelle : ANOVA sur les données de 'Peakcounting'
	#si un facteur
	pkcount.anova <- mcq.peakcounting.anova(pkcount.mindiff,'extraction', Tukey="extraction") 

summary(pkcount.anova@resulttukey)

names(pkcount.anova@resulttukey)
str(pkcount.anova@resulttukey$a2.a1.a1)
print(pkcount.anova@resulttukey$a2.a1.a1$groups)

# chargement du paquet
	library('MassChroqR')

# changement du répertoire de travail (remplacer /chemin/vers/repertoire_de_travail par votre arborescence)
	setwd ('/tmp')

setwd ('/home/langella/developpement/git/masschroqr/test/data/')

############################################################################################################################################################################
################################# Mise en forme des données  ###############################################################################################################
############################################################################################################################################################################
### NB : le fichier XIC_result_prot.tsv ne doit pas contenir d'apostrophes sous peine de lecture incomplète !!

################################# Création de l'objet protPep

# chargement des données d'identification et de quantification sorties de MassChroQ: mettre le fichier prot en premier
### NB: les aires sous le pic sont transformées en log (base 10) à cette étape
	protPep <- read.mcqProtPep('/gorgone/pappso/formation/Decembre2014/XIC_result_prot.tsv', '/gorgone/pappso/formation/Decembre2014/XIC_result_pep.tsv')

# visualiser la structure de l'objet protPep
	str(protPep)

# affichage du résumé du contenu de l'objet protPep
	summary (protPep)
#number of proteins : 
#number of XICs : 
#number of peptiz : (=  peptide-charge)
#number of peptides : 
#number of samples : 
	

################################# Création des métadata contenant la description des échantillons

# export d'un template dans lequel pourront être ajouté les métadata
	mcq.write.metadata.tsv(protPep, 'metadata.tsv')

# Ajout des metadata: ouvrir le fichier outfile.csv sous libreoffice ou excel, ajouter des colonnes (par exemple:traitement, rep , génotype, etc. ) permettant de décrire les échantillons et enregistrer en conservant le format csv

# import des métadata
	metadata <- read.mcq.metadata.ods('/gorgone/pappso/formation/Decembre2014/metadata.ods')

# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)



############################################################################################################################################################################
################################# Vérification de la qualité des données de chromatographie ################################################################################
############################################################################################################################################################################
### NB: on vérifie la largeur moyenne des pics et la déviation des temps de rétention pour éviter les missmatch et les erreurs eventuelles d'attribution de masse à un pic

# affichage de l'histogramme de distribution de la largeur moyenne des pics
	mcqPlotPeakWidth(protPep)					# affichage à l'écran
	mcqPlotPeakWidth(protPep, pdf='peak.pdf') 	# pour enregistrer le graphique sous format pdf

# suppression des XICs dont la largeur est trop longue (temps de rétention en secondes. ici, 100 sec)
	protPep <- mcqDropPeakWidth(protPep, cutoff=100)

# affichage du résumé du contenu de l'objet protPep après suppression des peptides
	summary(protPep)

# affichage de l'histogramme de distribution de la déviation des temps de rétention
	mcqPlotRetentionTimeSd(protPep)							# affichage à l'écran et paramètre "limit" par défaut
	mcqPlotRetentionTimeSd(protPep, pdf="RT.pdf",limit=40)  # limiter l'affichage des temps de rétention à 40s maximum (ici)

# suppression des peptides ayant une déviation supérieure à un seuil à déterminer en fonction de l'histogramme précédent (ici, 20 sec)
	protPep <- mcqDropRetentionTimeSd(protPep, cutoff=20)

# affichage du résumé du contenu de l'objet protPep après suppression des peptides
	summary(protPep)

# Statistiques exploratoires : ACP sur les peptides (peptiz / échantillons)
	peptidepca <- mcqNewPeptidePCA(protPep)

# Statistiques exploratoires : ACP sur les peptides (peptiz / extraction)
#	peptidepca_extraction <- mcqNewPeptidePCA(protPep, "extraction")

# écriture du résultat de l'ACP dans un fichier pour un traitement dans un logiciel externe
	mcq.write.tsv(peptidepca, csv="peptidepca.tsv")

# visualisation des axes de l'ACP

	mcqPlotPeptidePCA(peptidepca, colors="extraction", pdf="peptide_pca_avant_normalisation.pdf")


############################################################################################################################################################################
################################# Analyse par 'Peakcounting' (Variations qualitatives) ################################################################################
############################################################################################################################################################################


# comptage du nombre de 'peak' (= peptide-charge) par protéine dans chaque échantillon
	pkcount <- mcq.peak.counting(protPep)

	pkcount.mindiff <- mcq.select.mindiff(pkcount, 5, factor='extraction')
# export en format csv
	mcq.write.tsv(pkcount.mindiff, csv='pkcount.tsv')

# visualisation du nombre total de 'peaks', estimation de la qualité des échantillons et éventuellement enlever des échantillons
	mcqPlotPeakcountingPeakPerSamples(pkcount.mindiff)

#si un échantillon est "hors type", on peut le supprimer du jeu de données :
	summary(protPep)
	bis <- mcqDrop(protPep, 'msrun', 'samp11')
	summary(bis)
#dans ce cas, il faudra recompter le nombre de 'peak' sur ce nouveau jeu de données

# Statistique décisionnelle : ANOVA sur les données de 'Peakcounting'
	#si un facteur
	pkcount.anova <- mcq.peakcounting.anova(pkcount.mindiff,'extraction') 
	#si plusieurs facteurs
	#pkcount <- mcqPeakcountingAnova(pkcount,c('extraction','rep.bis'))

# Créer un tableau contenant le counting de peak par protéines et les résultats de l'ANOVA
	dfpeakcountinganova <- mcq.get.dataframe(pkcount.anova)
# Affichage des premières lignes du dataframe obtenu
	head(dfpeakcountinganova)

# Exporter les résultats de l'ANOVA au format csv
	mcq.write.compar.tsv(pkcount.anova, 'pkcount_anova.tsv')

# pvalue => seuil de pvalue
# mindiff => différence minimum entre min max (nombres de pics)
	pkcount.anova.signif <- mcq.select.anova.signif(pkcount.anova, pvalue=0.01,factor='extraction')

# Boxplot des protéines signif en fonction du facteur choisi
# (par défaut, c'est le facteur utilisé dans l'ANOVA qui sera pris en compte)
	mcq.plot.peakcounting.anova(pkcount.anova.signif, pdf='AnovaSignifPeakCounting.pdf')

# Créer un tableau contenant les résultats de l'anova du peak counting et les résultats de l'anova pour les protéines avec un effet traitement significatif
	dfpeakcountinganovasignif <- mcq.get.dataframe(pkcount.anova.signif)

# Exporter les résultats pour les protéines significatives au format csv
	mcq.write.tsv(pkcount.anova.signif, 'pkcount_anova_signif.csv')

# Combien de protéines avons-nous maintenant ?
	summary (protPep)



############################################################################################################################################################################
################################# Analyse quantitative (XIC)   #############################################################################################################
############################################################################################################################################################################

################################# Normalisation des données (les aires sont en log10)

# Visualisation des histogrammes de distribution des intensités de peptide dans chaque échantillon
	mcqPlotDistribQlog(protPep)

# Visualisation des histogrammes de distribution des différences des log d'intensité de peptide entre un échantillon donné et l'échantillon choisi comme référence (ici samp0)
	mcqPlotDistribQlogDiffRef(protPep, 'samp0', pdf='distrib_visu.pdf')

# Visualisation de la corrélation entre les intensités de peptides mesurées dans un échantillon donné et celles mesurées dans l'échantillon de référence (ici samp0)
	mcqPlotDistribQlogCometDiff(protPep, 'samp0', pdf="correlation_intensite_peptides.pdf")

# Normalisation par la médiane des différences d'intensité de peptides
	protPep <- mcqNormalizeBySampleref(protPep, 'samp0')

# Visualisation de l'effet de la normalisation
	mcqPlotNormalizationEffect(protPep, pdf='normalization_effect.pdf')


################################# Filtre des données : sélection des peptides reproductibles, des peptides spécifiques et des peptides corrélés d'une même protéine

# Histogramme du nombre d'échantillons dans lesquels un peptide a été quantifié
	mcq.plot.peptide.reproducibility(protPep, pdf='PeptideRepetables.pdf')

# Suppression des peptides non répétables (présents dans moins de 5% des échantillons)
# pct.max.mq => % max de valeurs manquantes
	protPep <- mcq.drop.unreproducible.peptides(protPep, method="percent", percentCutoff=0.05) 

#Quantification des protéines uniquement avec leurs peptides spécifiques
# Histogramme du nombre de protéines par peptide
	mcqPlotPeptidesSharedByProt(protPep, pdf = 'PeptidesPartages.pdf')

# Suppression des peptides communs à plusieurs protéines
	protPep <- mcqDropSharedPeptides(protPep)

# Selon nombre de modalités du facteur choisir étape a ou étape b
# a /Si le facteur "traitement" présente au moins 3 conditions (modalités) : filtre sur la correlation entre les peptides d'une même protéine
	protPep <- mcqDropUncorrelatedPeptides(protPep, 'extraction')
# b /Si le facteur "traitement" présente moins de 3 modalités : on ne garde que les protéines quantifiées par au moins 2 peptides
	protPep = mcqSelect2pepbyprot(protPep,'extraction')
	

################################# Imputation des valeurs manquantes par régression linéaire
	protPepnona <- mcqDataImputations(protPep, 'extraction')


################################# Représentation ACP à partir des intensités de peptide
	pcapeptide <- mcqNewPeptidePCA(protPep)
# représentation des 5 premiers axes de l'ACP.
# On choisit de colorier les échantillons en fonctions du facteur traitement (colors='traitement')
	mcqPlotPeptidePCA(pcapeptide, colors='extraction', pdf='peptide_pca_apres_normalisation.pdf')
# coordonnées spatiales des échantillons
	mcq.write.tsv(pcapeptide, 'pcapeptide.csv')
# écriture des composantes (peptides/z)
	mcq.write.tsv(pcapeptide, 'pcapeptide_comp.csv', comp=T)


################################# Calcul de la quantité par protéine

# Calcul des quantités de protéine (somme des peptides)
	qprot <- mcq.protquantity(protPepnona)

# Histogramme de distribution des écart-types des quantités de protéine
	mcqPlotProteinValueSd(qprot, pdf='SD_logQNorm.pdf')
	head(qprot@protval)

#Création d'un tableau à 2 dimensions : échantillons/protéines
	tacp <- mcq.get.compar(qprot)
	head(tacp)

# Export au format tabulé 
	mcq.write.compar.tsv(qprot, 'tacp_na.csv')

# dans les cas où il n'y avait pas de peptide de la protéine présent dans l'échantillon, on a encore un NA.
# on remplace le NA par la valeur min trouvée pour cette protéine dans l'expérience.
	qprot <- mcqReplaceNaProteinValueByMin(qprot)

	mcq.write.compar.tsv(qprot, 'tacp_nona.csv')

	mcqPlotProteinValueSd(qprot, pdf ='SD_logQNormMIN.pdf')



# Elimination des protéines qui ne varient pas beaucoup
# cutoff => seuil minimum accepté pour l'écart type en valeur absolue (0.05=trop faible pour une valeur absolue)
# Regarder l'ecart type et adapter en fonction
	test <- mcq.drop.protquantity.sd(qprot,cutoff=0.05)
	mcqPlotProteinValueSd(test)
	mcqPlotProteinValueSd(qprot)

################################# Représentation ACP à partir des quantités de protéine
	pca <- mcqNewProteinPCA(qprot)
# export du résultat de l'ACP dans un fichier pour manipulations dans un logiciel externe
# coordonnées spatiales des échantillons
	mcq.write.tsv(pca, 'proteinpca.csv')
# écriture des composantes (protéines)
	mcq.write.tsv(pca, 'proteinpca_comp.csv', comp=T)

#visualisation des résultats de l'ACP (écrit dans un fichier pdf)
	mcqPlotProteinPCA(pca, colors='extraction', pdf='acp_protein.pdf')

################################# ANOVA, Heatmap et clustering sur les protéines

#ANOVA à 1 facteur
	anova <- mcq.anova (qprot, 'extraction')
# Visualisation de l'histogramme des pvalues de l'ANOVA
  mcq.plot.pvalues(anova, "extraction") 
  mcq.plot.pvalues(anova, "extraction", pdf="anova_hist_extraction.pdf") 
# 0.05 => seuil de signif sur le facteur "extraction"
	anova.signif <- mcq.select.anova.signif(anova, 0.05, factor='extraction')
# Boxplot des protéines signif
  mcq.plot.anova(anova.signif, pdf="boxplot_protein_anova_signif.pdf")
# Ecriture des résultats de l'ANOVA dans un fichier :
# => totalité des résultats
	mcq.write.tsv(anova, 'anova.tsv')
# => uniquement les protéines signif
	mcq.write.tsv(anova.signif, 'anova_signif.tsv')

# on récupère la liste des protéines significatives déterminée par l'ANOVA
	protlist.signif <- mcq.get.protlist(anova.signif)
# on sélectionne les protéines quantifiées qui sont présentes dans la liste
	qprot.signif <- mcq.select.protlist(qprot, protlist.signif)

# on peut visualiser ces protéines sur un heatmap en fonction d'un facteur
	mcqPlotHeatmap(qprot.signif, factor="extraction", pdf="heatmap_qprot_anova_signif.pdf")
	mcqPlotHeatmapMeanRep(qprot.signif,factor="extraction",'classification_by_conditions.pdf')

# Regroupement des protéines en clusters
	mcqPlotCluster(qprot.signif,factor="extraction",nbclust=8,pdf='cluster.pdf')
	mcqPlotClusterMeanRep(qprot.signif,factor="extraction", nbclust=8, pdf='cluster_by_conditions.pdf')

# ecriture des infos clusters
	mcqClusterMeanRepInfoWriteCsv(qprot.signif,factor="extraction", nbclust=8, file='infos_cluster.csv')



################################## Récupération des informations de Spectral Counting ##################################################
# Pour éventuellement merger les données de Spectral Counting, Peak counting et XIC

# ATTENTION pour l'instant preparer la feuille comparspectra dans un fichier csv (bug read.ods pour fichier avec plusieurs onglets)
	spectral.count = read.mcq.spectralcounting('/gorgone/pappso/formation/Decembre2014/comparspectra.csv')

summary(spectral.count)
# merge avec les metadata
	spectral.count = mcq.merge.metadata(spectral.count, metadata)

	spectral.count.anova <- mcq.anova(spectral.count,'extraction')

#ecriture fichier spectral counting + pvalue
	mcq.write.compar.tsv(spectral.count.anova, 'spectralcount.csv')


# Statistique décisionnelle : ANOVA sur les données de 'SpectralCounting'
# 0.01 => seuil de pvalue
	spectral.count.anova.signif <- mcq.select.anova.signif(spectral.count.anova, 0.01, factor='extraction')
# => faire un boxplot des protéines signif en fonction du facteur choisi
# (par défaut, c'est le facteur utilisé dans l'anova qui sera pris en compte)
  mcq.plot.anova(spectral.count.anova.signif, pdf='AnovaSignifSpectralCounting.pdf')

# Créer un tableau contenant les résultats de l'anova du spectral counting et les résultats de l'ANOVA pour les protéines avec un effet traitement significatif
	dfspectral.count.anova.signif <- mcq.get.dataframe(spectral.count.anova.signif)

# Exporter les résultats pour les protéines significatives au format csv
	mcq.write.tsv(spectral.count.anova.signif, 'spectral_count_anova_signif.csv')


############ comparaisons par paires
protselect.all <- mcq.get.protlist(qprot)

pairs <- mcq.pairwise.t.test(qprot, "extraction")

mcq.plot.pvalues(pairs, pdf="pairs_pval.pdf")

protselect.fdr <- mcq.get.protlist(pairs, fdr=0.05)

mcq.plot.pairwise.t.test(mcq.select.pairwise.t.test.signif.fdr(pairs, fdr=0.05), pdf="pairs_signif.pdf")

pairs.mindiff <- mcq.select.pairwise.t.test.mindiff(pairs, diff.log10=0.06)

mcq.plot.pairwise.t.test(mcq.select.pairwise.t.test.signif.fdr(pairs.mindiff, fdr=0.05), pdf="pairs_signif_mindiff.pdf")
