library("MassChroqR")
cat(paste(Sys.time(),"\n",sep =""))

dir.create("/tmp/test_MassChroqR", showWarnings = FALSE)

dir.create("/tmp/test_MassChroqR/test_acp", showWarnings = FALSE)

setwd ("/tmp/test_MassChroqR/test_acp")

cat("test ACP\n")

if (file.exists("protpep.RData")) {
	load("protpep.RData")
	#load("protpep_metadata_one_factor.RData")
} else {
	protPep <- mcq.read.protpep("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", "/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")

	# import des métadata
	metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")
	#metadata.one.factor <- mcq.read.metadata('/gorgone/pappso/formation/Decembre2014/metadata_one_factor.ods')

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	#protpep.metadata.one.factor <- mcq.merge.metadata(protPep, metadata.one.factor)
	save(protPep, file="protpep.RData")
	#save(protpep.metadata.one.factor, file="protpep_metadata_one_factor.RData")
}

cat("error test 1 : bad object\n")
result <- tryCatch({

		mcq.plot.pca(protPep,file="pep_acp0factor_0factorToColor_0labels.pdf")
			
		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat("#####################################\n")
			cat (" error message expected OK\n")
			cat("#####################################\n")

			return()

		})

# sans facteur dans mcq.pca

cat("test ACP peptides sans facteur dans mcq.pca\n")

if (file.exists("peptidepca_noFactorList.RData")) {
	cat("load peptidepca_noFactorList.RData\n")
	load("peptidepca_noFactorList.RData")
	#load("peptidepca_metaone_noFactorList.RData")
}else{
	cat("mcq.pca(protPep)\n")
	peptidepca <- mcq.pca(protPep)
	save(peptidepca, file="peptidepca_noFactorList.RData")
	#peptidepcametaone <- mcq.pca(protpep.metadata.one.factor)
	#save(peptidepcametaone, file="peptidepca_metaone_noFactorList.RData")
}
#write("***** structure peptidepca *****" , 'Result_test.txt',append=TRUE)
#	str(peptidepca)

cat("plots files generation\n" )
#head (peptidepcametaone)
#mcq.plot.pca(peptidepcametaone, factorToColor="sample",file="pep_acp0factor_1factorToColor_0labels_metaone.pdf")
	mcq.plot.pca(peptidepca,file="pep_acp0factor_0factorToColor_0labels.pdf")
	mcq.plot.pca(peptidepca,file="pep_acp0factor_0factorToColor_1labels.pdf", labels = "extraction")
	mcq.plot.pca(peptidepca,file="pep_acp0factor_0factorToColor_2labels.pdf", labels = c("extraction","rep"))
	mcq.plot.pca(peptidepca, factorToColor="extraction",file="pep_acp0factor_1factorToColor_0labels.pdf")
	mcq.plot.pca(peptidepca, factorToColor="extraction",file="pep_acp0factor_1factorToColor_1labels.pdf", labels = "extraction")
	mcq.plot.pca(peptidepca, factorToColor="extraction",file="pep_acp0factor_1factorToColor_2labels.pdf", labels = c("extraction","rep"))
	mcq.plot.pca(peptidepca, factorToColor=c("extraction","rep"),file="pep_acp0factor_2factorToColor_0label.pdf")
	mcq.plot.pca(peptidepca, factorToColor=c("extraction","rep"),file="pep_acp0factor_2factorToColor_1label.pdf",labels="extraction")
	mcq.plot.pca(peptidepca, factorToColor=c("extraction","rep"),file="pep_acp0factor_2factorToColor_2label.pdf",labels=c("extraction","rep"))

# écriture du résultat de l'ACP dans un fichier pour un traitement dans un logiciel externe
cat("acp file\n")
	mcq.write.tsv(peptidepca, file="peptideACP0factor.tsv")

# écriture des composantes de l'ACP dans un fichier pour un traitement dans un logiciel externe
cat("composant acp file\n")
	mcq.write.tsv(peptidepca, file="componant_peptideACP0factor.tsv",comp=TRUE)
	
cat("error test 2 : bad factor for labels\n")
result <- tryCatch({

		mcq.plot.pca(peptidepca,file="pep_acp0factor_0factorToColor_1badlabels.pdf", labels = "badlabel")
			
		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat("#####################################\n")
			cat (" error message expected OK\n")
			cat("#####################################\n")

			return()

		})


cat("###################################\n")
cat("     test ACP peptides sans facteur dans mcq.plot.pca       OK \n")
cat("###################################\n")

##############################################################################
# avec 1 facteur dans mcq.pca= on calcule la moyenne pour le facteur indiqué

cat("test ACP peptides avec 1 facteur dans mcq.pca\n")

if (file.exists("peptidepca_1FactorList.RData")) {
	load("peptidepca_1FactorList.RData")
}else{
	peptidepca <- mcq.pca(protPep, flist="extraction")
	save(peptidepca, file="peptidepca_1FactorList.RData")
}
#cat("***** structure peptidepca *****\n")
#	str(peptidepca)


cat("plots files generation\n")
	mcq.plot.pca(peptidepca,file="pep_acp1factor_0factorToColor_0labels.pdf")
	mcq.plot.pca(peptidepca,file="pep_acp1factor_0factorToColor_1labels.pdf", labels = "extraction")

cat("error test 3 : too many factor for labels\n") 
cat ("plot acp : 1 factor,factorToColor=NULL, labels=extraction,rep))\n")
result <- tryCatch({

			mcq.plot.pca(peptidepca,file="pep_acp1factor_0factorToColor_2labels.pdf", labels = c("extraction","rep"))
			
		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat("#####################################\n")
			cat (" error message expected OK\n")
			cat("#####################################\n")

			return()

		})

	mcq.plot.pca(peptidepca, factorToColor="extraction",file="pep_acp1factor_1factorToColor_0labels.pdf")
	mcq.plot.pca(peptidepca, factorToColor="extraction",file="pep_acp1factor_1factorToColor_1labels.pdf", labels = "extraction")

cat("error test 4 : label not in agreement with acp factor\n ") 
cat("plot acp : 1 factor, 1 factorToColor=extraction, labels = rep)\n")
result <- tryCatch({

			mcq.plot.pca(peptidepca, factorToColor="extraction",file="pep_acp1factor_1factorToColor_1labels.pdf", labels = "rep")
			
		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat("#####################################\n")
			cat (" error message expected OK\n")
			cat("#####################################\n")

			return()

		})

	mcq.plot.pca(peptidepca, factorToColor="extraction",file="pep_acp1factor_1factorToColor_rep_1labels_extraction.pdf", labels = "extraction")

cat("error test 5 : too many factors for factorToColor\n")
cat ("plot acp : 1 factor, 2 factorToColor=extraction,rep, labels=NULL\n")
result <- tryCatch({

			mcq.plot.pca(peptidepca, factorToColor=c("extraction","rep"),file="pep_acp1factor_2factorToColor_0label.pdf")
			
		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat("#####################################\n")
			cat (" error message expected OK\n")
			cat("#####################################\n")

			return()

		})

cat ("plot acp : 1 factor, 2 factorToColor=(extraction,rep), labels =extraction)\n")
result <- tryCatch({

			mcq.plot.pca(peptidepca, factorToColor=c("extraction","rep"),file="pep_acp1factor_2factorToColor_1label.pdf",labels="extraction")
			
		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat("#####################################\n")
			cat (" error message expected OK\n")
			cat("#####################################\n")

			return()

		})

# écriture du résultat de l'ACP dans un fichier pour un traitement dans un logiciel externe

cat("acp file\n")
	mcq.write.tsv(peptidepca, file="peptideACP1factor.tsv")

# écriture des composantes de l'ACP dans un fichier pour un traitement dans un logiciel externe

cat("composant acp file\n")
	mcq.write.tsv(peptidepca, file="componant_peptideACP1factor.tsv",comp=TRUE)

cat("\n")
cat("#####################################\n")
cat("      test ACP peptides avec 1 facteur dans mcq.pca       OK \n")
cat("#####################################\n")

# avec 2 facteurs dans mcq.pca= on calcule la moyenne pour le facteur indiqué
cat("test ACP peptides avec 2 facteurs dans mcq.pca\n")

if (file.exists("peptidepca_2FactorList.RData")) {
	load("peptidepca_2FactorList.RData")
}else{
	peptidepca <- mcq.pca(protPep, flist=c("extraction","rep"))
	save(peptidepca, file="peptidepca_2FactorList.RData")
}

#cat("***** structure peptidepca *****\n")
#	str(peptidepca)

cat("plots files generation\n")
	mcq.plot.pca(peptidepca,file="pep_acp2factors_0factorToColor_0labels.pdf")
	mcq.plot.pca(peptidepca,file="pep_acp2factors_0factorToColor_1labels.pdf", labels = "extraction")
	mcq.plot.pca(peptidepca,file="pep_acp2factors_0factorToColor_2labels.pdf", labels = c("extraction","rep"))
	mcq.plot.pca(peptidepca, factorToColor="extraction",file="pep_acp2factors_1factorToColor_0labels.pdf")
	mcq.plot.pca(peptidepca, factorToColor="extraction",file="pep_acp2factors_1factorToColor_1labels.pdf", labels = "extraction")
	mcq.plot.pca(peptidepca, factorToColor="extraction",file="pep_acp2factors_1factorToColor_1labels.pdf", labels = "rep")
	mcq.plot.pca(peptidepca, factorToColor="extraction",file="pep_acp2factors_1factorToColor_1labels.pdf", labels = "extraction")
	mcq.plot.pca(peptidepca, factorToColor="extraction",file="pep_acp2factors_1factorToColor_2labels.pdf", labels = c("extraction","rep"))
	mcq.plot.pca(peptidepca, factorToColor=c("extraction","rep"),file="pep_acp2factors_2factorToColor_0label.pdf")
	mcq.plot.pca(peptidepca, factorToColor=c("extraction","rep"),file="pep_acp2factors_2factorToColor_1label.pdf",labels="extraction")
	mcq.plot.pca(peptidepca, factorToColor=c("extraction","rep"),file="pep_acp2factors_2factorToColor_2label.pdf",labels=c("extraction","rep"))

# écriture du résultat de l'ACP dans un fichier pour un traitement dans un logiciel externe

cat("acp file\n")
	mcq.write.tsv(peptidepca, file="peptideACP2factors.tsv")

# écriture des composantes de l'ACP dans un fichier pour un traitement dans un logiciel externe

cat(" composant acp file\n")
	mcq.write.tsv(peptidepca, file="componant_peptideACP2factors.tsv",comp=TRUE)


cat("\n")
cat("#####################################\n")
cat("      test ACP peptides avec 2 facteurs dans mcq.pca      OK \n")
cat("#####################################\n")

cat("PROTEINES\n")


if (file.exists("qprot.RData")) {
	load("qprot.RData")
} else {

	cat(" * Normalisation par la médiane des différences d'intensité de peptides\n")
	protPep <- mcq.normalize(protPep, refSample='sampa0')
	cat(" * Imputation des valeurs manquantes par r?gression linéaire\n")
	protPepnona <- mcq.impute(protPep)
	#cat("***** structure protPepnona *****\n")
	#str(protPepnona)
	qprot <- mcq.protquantity(protPepnona)
	#cat("***** structure qprot *****\n")
	#str(qprot)
	save(qprot, file="qprot.RData")
}

# sans facteur dans mcq.pca

cat("test ACP proteines sans facteur dans mcq.pca\n")
if (file.exists("protpca_noFactorList.RData")) {
	load("protpca_noFactorList.RData")
}else{
	protpca <- mcq.pca(qprot)
	save(protpca, file="protpca_noFactorList.RData")
}
#cat("***** structure protpca *****\n")
#str(protpca)

cat("plots files generation\n")
	mcq.plot.pca(protpca,file="prot_acp0factor_0factorToColor_0labels.pdf")
	mcq.plot.pca(protpca,file="prot_acp0factor_0factorToColor_1labels.pdf", labels = "extraction")
	mcq.plot.pca(protpca,file="prot_acp0factor_0factorToColor_2labels.pdf", labels = c("extraction","rep"))
	mcq.plot.pca(protpca, factorToColor="extraction",file="prot_acp0factor_1factorToColor_0labels.pdf")
	mcq.plot.pca(protpca, factorToColor="extraction",file="prot_acp0factor_1factorToColor_1labels.pdf", labels = "extraction")
	mcq.plot.pca(protpca, factorToColor="extraction",file="prot_acp0factor_1factorToColor_2labels.pdf", labels = c("extraction","rep"))
	mcq.plot.pca(protpca, factorToColor=c("extraction","rep"),file="prot_acp0factor_2factorToColor_0label.pdf")
	mcq.plot.pca(protpca, factorToColor=c("extraction","rep"),file="prot_acp0factor_2factorToColor_1label.pdf",labels="extraction")
	mcq.plot.pca(protpca, factorToColor=c("extraction","rep"),file="prot_acp0factor_2factorToColor_2label.pdf",labels=c("extraction","rep"))

# écriture du résultat de l'ACP dans un fichier pour un traitement dans un logiciel externe

cat("acp file\n")
	mcq.write.tsv(protpca, file="proteinesACP0factor.tsv")

# écriture des composantes de l'ACP dans un fichier pour un traitement dans un logiciel externe

cat("composant acp file\n")
	mcq.write.tsv(protpca, file="componant_proteinesACP0factor.tsv",comp=TRUE)


cat("###################################\n")
cat("     test ACP proteines sans facteur dans mcq.pca       OK \n")
cat("###################################\n")

##############################################################################
# avec 1 facteur dans mcq.pca= on calcule la moyenne pour le facteur indiqué

cat("test ACP proteines avec 1 facteur dans mcq.pca\n")

if (file.exists("protpca_1FactorList.RData")) {
	load("protpca_1FactorList.RData")
}else{
	protpca <- mcq.pca(qprot, flist="extraction")
	save(protpca, file="protpca_1FactorList.RData")
}
#cat("***** structure protpca *****\n")
#	str(protpca)

cat("plots files generation\n")
	mcq.plot.pca(protpca,file="prot_acp1factor_0factorToColor_0labels.pdf")
	mcq.plot.pca(protpca,file="prot_acp1factor_0factorToColor_1labels.pdf", labels = "extraction")
	
cat("error test 6 : Too many factors chosen for labels\n")
cat("plot acp : 1 factor,factorToColor=NULL, labels=extraction,rep))\n")
result <- tryCatch({

			mcq.plot.pca(protpca,file="prot_acp1factor_0factorToColor_2labels.pdf", labels = c("extraction","rep"))
			
		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat("#####################################\n")
			cat (" error message expected OK\n")
			cat("#####################################\n")

			return()

		})

	mcq.plot.pca(protpca, factorToColor="extraction",file="prot_acp1factor_1factorToColor_0label.pdf")
	mcq.plot.pca(protpca, factorToColor="extraction",file="prot_acp1factor_1factorToColor_1label.pdf", labels = "extraction")

cat("error test 7 : factor chosen for label not in agreement with acp factor\n")
cat("plot acp : 1 factor, 1 factorToColor=extraction, labels = rep)\n")
result <- tryCatch({

			mcq.plot.pca(protpca, factorToColor="extraction",file="prot_acp1factor_1factorToColor_1labels.pdf", labels = "rep")
			
		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat("#####################################\n")
			cat (" error message expected OK\n")
			cat("#####################################\n")

			return()

		})

	mcq.plot.pca(protpca, factorToColor="extraction",file="prot_acp1factor_1factorToColor_rep_1label_extraction.pdf", labels = "extraction")

cat("error test 8 : Too many factors chosen for labels\n")
cat ("plot acp : 1 factor, 1 factorToColor=extraction, labels = (extraction,rep))\n")
result <- tryCatch({

			mcq.plot.pca(protpca, factorToColor="extraction",file="prot_acp1factor_1factorToColor_2labels.pdf", labels = c("extraction","rep"))
			
		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat("#####################################\n")
			cat (" error message expected OK\n")
			cat("#####################################\n")

			return()

		})

cat("error test 9 : Too many factors chosen for factorToColor\n")
cat("plot acp : 1 factor, 2 factorToColor=c(extraction,rep), labels=NULL\n")
result <- tryCatch({

			mcq.plot.pca(protpca, factorToColor=c("extraction","rep"),file="prot_acp1factor_2factorToColor_0label.pdf")
			
		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat("#####################################\n")
			cat (" error message expected OK\n")
			cat("#####################################\n")

			return()

		})

cat("plot acp : 1 factor, 2 factorToColor=c(extraction,rep), labels = extraction)\n")
result <- tryCatch({

			mcq.plot.pca(protpca, factorToColor=c("extraction","rep"),file="prot_acp1factor_2factorToColor_1label.pdf",labels="extraction")
			
		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat("#####################################\n")
			cat (" error message expected OK\n")
			cat("#####################################\n")

			return()

		})

cat("plot acp : 1 factor, 2 factorToColor=c(extraction,rep), labels =c(extraction,rep))\n")
result <- tryCatch({

			mcq.plot.pca(protpca, factorToColor=c("extraction","rep"),file="prot_acp1factor_2factorToColor_2label.pdf",labels=c("extraction","rep"))
			
		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat("#####################################\n")
			cat (" error message expected OK\n")
			cat("#####################################\n")

			return()

		})

# écriture du résultat de l'ACP dans un fichier pour un traitement dans un logiciel externe
cat("acp file\n")
	mcq.write.tsv(protpca, file="proteinesACP1factor.tsv")

# écriture des composantes de l'ACP dans un fichier pour un traitement dans un logiciel externe
cat("composant acp file\n")
	mcq.write.tsv(protpca, file="componant_proteinesACP1factor.tsv",comp=TRUE)

cat("\n")
cat("#####################################\n")
cat("      test ACP proteines avec 1 facteur dans mcq.pca       OK \n")
cat("#####################################\n")

# avec 2 facteurs dans mcq.pca= on calcule la moyenne pour le facteur indiqué
cat("test ACP proteines avec 2 facteurs dans mcq.pca\n")

if (file.exists("protpca_2FactorList.RData")) {
	load("protpca_2FactorList.RData")
}else{
	protpca <- mcq.pca(qprot, c("extraction","rep"))
	save(protpca, file="protpca_2FactorList.RData")
}

#cat("***** structure protpca *****\n")
#	str(protpca)

cat("plots files generation\n")
	mcq.plot.pca(protpca,file="prot_acp2factors_0factorToColor_0labels.pdf")
	mcq.plot.pca(protpca,file="prot_acp2factors_0factorToColor_1labels.pdf", labels = "extraction")
	mcq.plot.pca(protpca,file="prot_acp2factors_0factorToColor_2labels.pdf", labels = c("extraction","rep"))
	mcq.plot.pca(protpca, factorToColor="extraction",file="prot_acp2factors_1factorToColor_0labels.pdf")
	mcq.plot.pca(protpca, factorToColor="extraction",file="prot_acp2factors_1factorToColor_1labels.pdf", labels = "extraction")
	mcq.plot.pca(protpca, factorToColor="extraction",file="prot_acp2factors_1factorToColor_1labels.pdf", labels = "rep")
	mcq.plot.pca(protpca, factorToColor="extraction",file="prot_acp2factors_1factorToColor_1labels.pdf", labels = "extraction")
	mcq.plot.pca(protpca, factorToColor="extraction",file="prot_acp2factors_1factorToColor_2labels.pdf", labels = c("extraction","rep"))
	mcq.plot.pca(protpca, factorToColor=c("extraction","rep"),file="prot_acp2factors_2factorToColor_0label.pdf")
	mcq.plot.pca(protpca, factorToColor=c("extraction","rep"),file="prot_acp2factors_2factorToColor_1label.pdf",labels="extraction")
	mcq.plot.pca(protpca, factorToColor=c("extraction","rep"),file="prot_acp2factors_2factorToColor_2label.pdf",labels=c("extraction","rep"))

# écriture du résultat de l'ACP dans un fichier pour un traitement dans un logiciel externe

cat("acp file\n")
	mcq.write.tsv(protpca, file="proteinesACP2factors.tsv")

# écriture des composantes de l'ACP dans un fichier pour un traitement dans un logiciel externe
cat("composant acp file\n")
	mcq.write.tsv(protpca, file="componant_proteinesACP2factors.tsv",comp=TRUE)

cat("\n")
cat("#####################################\n")
cat("      test ACP proteines avec 2 facteurs dans mcq.pca      OK \n")
cat("#####################################\n")

cat("\n")
cat("##################################\n")
cat("      IF ALL TESTS        OK   => cf pdf files                            \n")
cat("##################################\n")

