library("MassChroqR")
packageVersion("MassChroqR")

cat(paste(Sys.time(),"\n",sep =""))

dir.create("/tmp/test_MassChroqR", showWarnings = FALSE)

dir.create("/tmp/test_MassChroqR/test_masschroq_filters_drop", showWarnings = FALSE)

setwd ("/tmp/test_MassChroqR/test_masschroq_filters_drop")

cat("Test masschroq_filters_drop\n")


if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- mcq.read.protpep("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", "/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")

	# import des métadata
	metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}

cat("\n")
cat("#####################################\n")
cat("      initial summary \n")
cat("#####################################\n")
summary(protPep)
	
cat("\n")
cat("#####################################\n")
cat("      function mcq.drop.variable.rt \n")
cat("#####################################\n")

protPep <- mcq.drop.variable.rt(protPep, cutoff=20)

if (length(unique(protPep@peptides$peptide)) == length(unique(protPep@proteins$peptide))) {
	cat("\n")
	cat("      nb peptide slot proteins = nb peptide slot peptides OK \n")
}

if(length(unique(protPep@peptides$peptide))==10459){
	cat("\n")
	cat("      nb peptides = 10459  OK \n")

}else{
	cat("\n")
	cat("      ERROR nb peptides !=  10459 \n")
	cat(length(unique(protPep@peptides$peptide)))
	cat("\n")

}

cat("\n")
cat("#####################################\n")
cat("      function mcq.drop.wide.peaks \n")
cat("#####################################\n")

protPep <- mcq.drop.wide.peaks(protPep, cutoff=100)

if (length(unique(protPep@peptides$peptide)) == length(unique(protPep@proteins$peptide))) {
	cat("\n")
	cat("      nb peptide slot proteins = nb peptide slot peptides OK \n")
}

if(length(unique(protPep@peptides$peptide))==10458){
	cat("\n")
	cat("      nb peptides = 10458  OK \n")

}else{
	cat("\n")
	cat("      ERROR nb peptides !=  10458 \n")
	cat(length(unique(protPep@peptides$peptide)))
	cat("\n")

}

cat("\n")
cat("#####################################\n")
