library("MassChroqR")
packageVersion("MassChroqR")
cat(paste(Sys.time(),"\n",sep =""))
cat("\n")

dir.create("/tmp/test_MassChroqR", showWarnings = FALSE)

dir.create("/tmp/test_MassChroqR/test_mcq.plot.counts.per.sample", showWarnings = FALSE)

setwd ("/tmp/test_MassChroqR/test_mcq.plot.counts.per.sample")

if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	#protPep <- mcq.read.protpep("/gorgone/pappso/formation/Decembre2014/XIC_result_prot.tsv", "/gorgone/pappso/formation/Decembre2014/XIC_result_pep.tsv")
	protPep <- mcq.read.protpep(protFile="/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", pepFile="/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")

	# import metadata
	#metadata <- mcq.read.metadata("/gorgone/pappso/formation/Decembre2014/metadata.ods")
	metadata.info <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/masschroqr/metadata.ods")

	# add metadata to the objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata.info)
	save(protPep, file="protpep.RData")
}

if (file.exists("pkcount.RData")) {
	load("pkcount.RData")
} else {
	pkcount <- mcq.peak.counting(protPep)
	save(pkcount, file="pkcount.RData")
}


cat ("*********************************************\n")
cat("  Test mcq.plot.counts.per.sample\n")
cat ("*********************************************\n")

mcq.plot.counts.per.sample(pkcount,file="QUAL_peak_counts_per_sample.pdf")
