library("MassChroqR")

cat(paste(Sys.time(),"\n",sep =""))

dir.create("/tmp/test_MassChroqR", showWarnings = FALSE)

dir.create("/tmp/test_MassChroqR/test_mcq_cv", showWarnings = FALSE)

setwd ("/tmp/test_MassChroqR/test_mcq_cv")

cat("Test mcq cv\n" )


if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- mcq.read.protpep("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", "/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")

	# import des métadata
	metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}

if (file.exists("protq.RData")) {
	load("protq.RData")
} else {
	qprot <- mcq.protquantity(protPep)
	save(qprot, file="protq.RData")
}
# test parameter
result <- tryCatch({
			
			cv = mcq.get.cv(protPep, "je sais pas")

		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat ("*********************************************\n")
			cat (" error message expected OK\n")
			cat ("*********************************************\n")

			return()

		})


cv = mcq.get.cv(protPep, "rep");
cat("summary cv protPep\n")

summary(cv)



protPep <- mcq.normalize(protPep, refSample = "sampa0")

cv = mcq.get.cv(protPep, "rep");
cat("summary cv on normalized protPep\n")

summary(cv)


cat ("*********************************************\n")
cat (" mcq.get.cv on protpep OK\n")
cat ("*********************************************\n")


cv = mcq.get.cv(qprot, "rep");
cat("summary cv qprot\n")
summary(cv)
head (cv)



if(as.character(cv[1, "rep"])=="1"){
	cat("test factor name  OK\n" )

	cat ("*********************************************\n")
	cat (" mcq.get.cv on prot OK\n")
	cat ("*********************************************\n")

}else{
	cat("ERROR cv[1, 'rep'] != 1 \n" )
	cat(as.character(cv[1, "rep"]), "\n" )

	cat ("*********************************************\n")
	cat (" mcq.get.cv ERROR\n")
	cat ("*********************************************\n")


}



