	
	library("MassChroqR")
	packageVersion("MassChroqR")

	cat(paste(Sys.time(),"\n",sep =""))

	dir.create("/tmp/test_MassChroqR", showWarnings = FALSE)

	dir.create("/tmp/test_MassChroqR/test_mcq_drop", showWarnings = FALSE)

	setwd ("/tmp/test_MassChroqR/test_mcq_drop")

############## Chargement des données
	cat ("*********************************************\n")
	cat("chargement des données\n")
	cat ("*********************************************\n")

	# protPep
	if (file.exists("protpep.RData")) {
	load("protpep.RData")
	} else {
	protPep <- mcq.read.protpep("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", "/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")

	# import des metadata
	metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")

	# Ajout des metadata a l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}

	# pkcount
	pkcount <- mcq.peak.counting(protPep)

	# qprot
	qprot <- mcq.protquantity(protPep)

	# spectral count
	spectral.count = mcq.read.spectralcounting("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/results_compar_spectra.txt")
	metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")
	spectral.count = mcq.merge.metadata(spectral.count, metadata)


############## test sur protPep
	cat("\n")
	cat ("*********************************************\n")
	cat("TEST SUR PROTPEP\n")
	cat ("*********************************************\n")

#test 1
	cat("\n")
	cat("\n")
	factor="msrun"
	levels="sampa1"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(protPep, factor=factor, levels=levels)

	cat("\n")
	cat("############# vérification du nb de msrun\n")
	cat("Test: nb de msrun final = nb de msrun initiaux - nb de msrun droppés?\n")
	length(unique(test@peptides$msrun))==length(unique(protPep@peptides$msrun))-length(levels)
	cat("Test: nb de msrun final qui sont dans les msrun droppés=0?\n")
	length(which(unique(test@peptides$msrun) %in% levels))==0

	cat("\n")
	cat("############# vérification de la cohérence des msrun\n")
	cat("Test: nb de msrun de @peptides - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@peptides$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @peptides - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@peptides$msrun)) - length(rownames(test@metadata@samples))==0

	cat("\n")
	cat("############# vérification de la cohérence des peptides\n")
	cat("Test: nb de peptides initiaux - nb de peptides finaux\n")
	length(unique(protPep@peptides$peptide)) - length(unique(test@peptides$peptide))
	cat("Test: nb de peptides dans @peptides = - nb de peptides dans @protein\n")
	length(unique(test@peptides$peptide)) == length(unique(test@proteins$peptide))


#test 2
	cat("\n")
	cat("\n")
	factor="peptide"
	levels="pepb28b35"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(protPep, factor=factor, levels=levels)

	cat("\n")
	cat("############# vérification de la cohérence des peptides\n")
	cat("Test: nb de peptides final = nb de peptides initiaux - nb de peptides droppés?\n")
	length(unique(test@peptides$peptide))==length(unique(protPep@peptides$peptide)) - length(levels)
	cat("Test: nb de peptides final qui sont dans les peptides droppés=0?\n")
	length(which(unique(test@peptides$peptide) %in% levels))==0
	cat("Test: nb de peptides dans @peptides = - nb de peptides dans @protein\n")
	length(unique(test@peptides$peptide)) == length(unique(test@proteins$peptide))

	cat("\n")
	cat("############# vérification de la cohérence des msrun\n")
	cat("Test: nb de msrun dans test = - nb de msrun dans protPep?\n")
	length(unique(test@peptides$msrun))==length(unique(protPep@peptides$msrun))
	cat("Test: nb de msrun de @peptides - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@peptides$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @peptides - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@peptides$msrun)) - length(rownames(test@metadata@samples))==0

#test 3
	cat("\n")
	cat("\n")
	factor="extraction"
	levels="urnb"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(protPep, factor=factor, levels=levels)

	cat("\n")
	cat("############# vérification de la cohérence des msrun\n")
	msrunListToDrop <- rownames(protPep@metadata@metadata[protPep@metadata@metadata[,factor] %in% levels,])
	length(msrunListToDrop)
	cat("Test: nb de msrun final = nb de msrun initiaux - nb de msrun droppés?\n")
	length(unique(test@peptides$msrun))==length(unique(protPep@peptides$msrun))-length(msrunListToDrop)
	cat("Test: nb de msrun final qui sont dans les msrun droppés=0?\n")
	length(which(unique(test@peptides$msrun) %in% msrunListToDrop))
	cat("Test: nb de msrun de @peptides - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@peptides$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @peptides - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@peptides$msrun)) - length(rownames(test@metadata@samples))==0

	cat("\n")
	cat("############# vérification de la cohérence des peptides\n")
	cat("Test: nb de peptides initiaux - nb de peptides finaux\n")
	length(unique(protPep@peptides$peptide)) - length(unique(test@peptides$peptide))
	cat("Test: nb de peptides dans @peptides = - nb de peptides dans @protein\n")
	length(unique(test@peptides$peptide)) == length(unique(test@proteins$peptide))

#test 4
	cat("\n")
	cat("\n")
	factor="protein"
	levels="a1.a3.a1"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(protPep, factor=factor, levels=levels)
	pep.dropped=protPep@proteins$peptide[protPep@proteins$protein %in% levels]

	cat("\n")
	cat("############# vérification de la cohérence des peptides\n")
	cat("Test: nb de peptides final = nb de peptides initiaux - nb de peptides droppés?\n")
	length(unique(test@peptides$peptide))==length(unique(protPep@peptides$peptide)) - length(pep.dropped)
	cat("Test: nb de peptides final qui sont dans les peptides droppés=0?\n")
	length(which(unique(test@peptides$peptide) %in% pep.dropped))==0
	cat("Test: nb de peptides dans @peptides = - nb de peptides dans @protein\n")
	length(unique(test@peptides$peptide)) == length(unique(test@proteins$peptide))

	cat("\n")
	cat("############# vérification de la cohérence des msrun\n")
	cat("Test: nb de msrun dans test = - nb de msrun dans protPep?\n")
	length(unique(test@peptides$msrun))==length(unique(protPep@peptides$msrun))
	cat("Test: nb de msrun de @peptides - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@peptides$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @peptides - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@peptides$msrun)) - length(rownames(test@metadata@samples))==0


#test 5	
	cat("\n")
	cat("\n")
	factor="accession"
	levels="GRMZM2G473001_P01"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(protPep, factor=factor, levels=levels)

	pep.dropped=protPep@proteins$peptide[protPep@proteins$accession %in% levels]

	cat("\n")
	cat("############# vérification de la cohérence des peptides\n")
	cat("Test: nb de peptides final = nb de peptides initiaux - nb de peptides droppés?\n")
	length(unique(test@peptides$peptide))==length(unique(protPep@peptides$peptide)) - length(pep.dropped)
	cat("Test: nb de peptides final qui sont dans les peptides droppés=0?\n")
	length(which(unique(test@peptides$peptide) %in% pep.dropped))==0
	cat("Test: nb de peptides dans @peptides = - nb de peptides dans @protein\n")
	length(unique(test@peptides$peptide)) == length(unique(test@proteins$peptide))

	cat("\n")
	cat("############# vérification de la cohérence des msrun\n")
	cat("Test: nb de msrun dans test = - nb de msrun dans protPep?\n")
	length(unique(test@peptides$msrun))==length(unique(protPep@peptides$msrun))
	cat("Test: nb de msrun de @peptides - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@peptides$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @peptides - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@peptides$msrun)) - length(rownames(test@metadata@samples))==0



############## test sur qprot
	cat("\n")
	cat ("*********************************************\n")
	cat("TEST SUR QPROT\n")
	cat ("*********************************************\n")

#test 1
	cat("\n")
	cat("\n")
	factor="msrun"
	levels="sampa1"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(qprot, factor=factor, levels=levels)

	cat("\n")
	cat("############# vérification du nb de msrun\n")
	cat("Test: nb de msrun final = nb de msrun initiaux - nb de msrun droppés?\n")
	length(unique(test@protval$msrun))==length(unique(qprot@protval$msrun))-length(levels)
	cat("Test: nb de msrun final qui sont dans les msrun droppés=0?\n")
	length(which(unique(test@protval$msrun) %in% levels))==0

	cat("\n")
	cat("############# vérification de la cohérence des msrun\n")
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@samples))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@samples))==0

	cat("\n")
	cat("############# vérification de la cohérence des proteines\n")
	cat("Test: nb de protéines initiales - nb de protéines finales\n")
	length(unique(qprot@protval$protein)) - length(unique(test@protval$protein))
	cat("Test: nb de protéines dans @proteines = - nb de proteines dans @protval\n")
	length(rownames(test@proteins)) == length(unique(test@protval$protein))


#test 2
	cat("\n")
	cat("\n")
	factor="extraction"
	levels="urnb"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(qprot, factor=factor, levels=levels)

	cat("\n")
	cat("############# vérification de la cohérence des msrun\n")
	msrunListToDrop <- rownames(qprot@metadata@metadata[qprot@metadata@metadata[,factor] %in% levels,])
	length(msrunListToDrop)
	cat("Test: nb de msrun final = nb de msrun initiaux - nb de msrun droppés?\n")
	length(unique(test@protval$msrun))==length(unique(qprot@protval$msrun))-length(msrunListToDrop)
	cat("Test: nb de msrun final qui sont dans les msrun droppés=0?\n")
	length(which(unique(test@protval$msrun) %in% msrunListToDrop))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@samples))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@samples))==0

	cat("\n")
	cat("############# vérification de la cohérence des proteines\n")
	cat("Test: nb de protéines initiales - nb de protéines finales\n")
	length(unique(qprot@protval$protein)) - length(unique(test@protval$protein))
	cat("Test: nb de protéines dans @proteines = - nb de proteines dans @protval\n")
	length(rownames(test@proteins)) == length(unique(test@protval$protein))

#test 3
	cat("\n")
	cat("\n")
	factor="protein"
	levels="a1.a3.a1"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(qprot, factor=factor, levels=levels)

	cat("\n")
	cat("############# vérification de la cohérence des proteines\n")
	cat("Test: nb de protéines initiales - nb de protéines finales\n")
	length(unique(qprot@protval$protein)) - length(unique(test@protval$protein))
	cat("Test: nb de protéines dans @proteines = - nb de proteines dans @protval\n")
	length(rownames(test@proteins)) == length(unique(test@protval$protein))

	cat("\n")	
	cat("############# vérification de la cohérence des msrun\n")
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@samples))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@samples))==0

#test 4	
	cat("\n")
	cat("\n")
	factor="accession"
	levels="GRMZM2G473001_P01"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(qprot, factor=factor, levels=levels)

	cat("\n")
	cat("############# vérification de la cohérence des proteines\n")
	cat("Test: nb de protéines initiales - nb de protéines finales\n")
	length(unique(qprot@protval$protein)) - length(unique(test@protval$protein))
	cat("Test: nb de protéines dans @proteines = - nb de proteines dans @protval\n")
	length(rownames(test@proteins)) == length(unique(test@protval$protein))

	cat("\n")	
	cat("############# vérification de la cohérence des msrun\n")
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@samples))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@samples))==0


############## test sur pkcount
	cat("\n")
	cat ("*********************************************\n")
	cat("TEST SUR PKCOUNT\n")
	cat ("*********************************************\n")

#test 1
	cat("\n")
	cat("\n")
	factor="msrun"
	levels="sampa1"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(pkcount, factor=factor, levels=levels)

	cat("\n")
	cat("############# vérification du nb de msrun\n")
	cat("Test: nb de msrun final = nb de msrun initiaux - nb de msrun droppés?\n")
	length(unique(test@protval$msrun))==length(unique(pkcount@protval$msrun))-length(levels)
	cat("Test: nb de msrun final qui sont dans les msrun droppés=0?\n")
	length(which(unique(test@protval$msrun) %in% levels))==0

	cat("\n")
	cat("############# vérification de la cohérence des msrun\n")
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@samples))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@samples))==0

	cat("\n")
	cat("############# vérification de la cohérence des proteines\n")
	cat("Test: nb de protéines initiales - nb de protéines finales\n")
	length(unique(pkcount@protval$protein)) - length(unique(test@protval$protein))
	cat("Test: nb de protéines dans @proteines =  nb de proteines dans @protval\n")
	length(rownames(test@proteins)) == length(unique(test@protval$protein))


#test 2
	cat("\n")
	cat("\n")
	factor="extraction"
	levels="urnb"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(pkcount, factor=factor, levels=levels)

	cat("\n")
	cat("############# vérification de la cohérence des msrun\n")
	msrunListToDrop <- rownames(pkcount@metadata@metadata[pkcount@metadata@metadata[,factor] %in% levels,])
	length(msrunListToDrop)
	cat("Test: nb de msrun final = nb de msrun initiaux - nb de msrun droppés?\n")
	length(unique(test@protval$msrun))==length(unique(pkcount@protval$msrun))-length(msrunListToDrop)
	cat("Test: nb de msrun final qui sont dans les msrun droppés=0?\n")
	length(which(unique(test@protval$msrun) %in% msrunListToDrop))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@samples))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@samples))==0

	cat("\n")
	cat("############# vérification de la cohérence des proteines\n")
	cat("Test: nb de protéines initiales - nb de protéines finales\n")
	length(unique(pkcount@protval$protein)) - length(unique(test@protval$protein))
	cat("Test: nb de protéines dans @proteines = - nb de proteines dans @protval\n")
	length(rownames(test@proteins)) == length(unique(test@protval$protein))

#test 3
	cat("\n")
	cat("\n")
	factor="protein"
	levels="a1.a3.a1"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(pkcount, factor=factor, levels=levels)

	cat("\n")
	cat("############# vérification de la cohérence des proteines\n")
	cat("Test: nb de protéines initiales - nb de protéines finales\n")
	length(unique(pkcount@protval$protein)) - length(unique(test@protval$protein))
	cat("Test: nb de protéines dans @proteines = - nb de proteines dans @protval\n")
	length(rownames(test@proteins)) == length(unique(test@protval$protein))

	cat("\n")	
	cat("############# vérification de la cohérence des msrun\n")
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@samples))==0
	cat("Test: nb de msrun de @proval - nb de msrun de @samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@samples))==0

#test 4	
	cat("\n")
	cat("\n")
	factor="accession"
	levels="GRMZM2G473001_P01"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(pkcount, factor=factor, levels=levels)

	cat("\n")
	cat("############# vérification de la cohérence des proteines\n")
	cat("Test: nb de protéines initiales - nb de protéines finales\n")
	length(unique(pkcount@protval$protein)) - length(unique(test@protval$protein))
	cat("Test: nb de protéines dans @proteines = - nb de proteines dans @protval\n")
	length(rownames(test@proteins)) == length(unique(test@protval$protein))
	
	cat("\n")
	cat("############# vérification de la cohérence des msrun\n")
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@samples))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@samples))==0


############## test sur spectral count
	cat ("*********************************************\n")
	cat("TEST SUR SPECTRAL COUNT\n")
	cat ("*********************************************\n")

#test 1
	cat("\n")
	cat("\n")
	factor="msrun"
	levels="sampa1"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(spectral.count, factor=factor, levels=levels)

	cat("\n")
	cat("############# vérification du nb de msrun\n")
	cat("Test: nb de msrun final = nb de msrun initiaux - nb de msrun droppés?\n")
	length(unique(test@protval$msrun))==length(unique(spectral.count@protval$msrun))-length(levels)
	cat("Test: nb de msrun final qui sont dans les msrun droppés=0?\n")
	length(which(unique(test@protval$msrun) %in% levels))==0

	cat("\n")
	cat("############# vérification de la cohérence des msrun\n")
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@samples))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@samples))==0

	cat("\n")
	cat("############# vérification de la cohérence des proteines\n")
	cat("Test: nb de protéines initiales - nb de protéines finales\n")
	length(unique(spectral.count@protval$protein)) - length(unique(test@protval$protein))
	cat("Test: nb de protéines dans @proteines =  nb de proteines dans @protval\n")
	length(rownames(test@proteins)) == length(unique(test@protval$protein))


#test 2
	cat("\n")
	cat("\n")
	factor="extraction"
	levels="urnb"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(spectral.count, factor=factor, levels=levels)

	cat("\n")
	cat("############# vérification de la cohérence des msrun\n")
	msrunListToDrop <- rownames(spectral.count@metadata@metadata[spectral.count@metadata@metadata[,factor] %in% levels,])
	length(msrunListToDrop)
	cat("Test: nb de msrun final = nb de msrun initiaux - nb de msrun droppés?\n")
	length(unique(test@protval$msrun))==length(unique(spectral.count@protval$msrun))-length(msrunListToDrop)
	cat("Test: nb de msrun final qui sont dans les msrun droppés=0?\n")
	length(which(unique(test@protval$msrun) %in% msrunListToDrop))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@samples))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@samples))==0

	cat("\n")
	cat("############# vérification de la cohérence des proteines\n")
	cat("Test: nb de protéines initiales - nb de protéines finales\n")
	length(unique(spectral.count@protval$protein)) - length(unique(test@protval$protein))
	cat("Test: nb de protéines dans @proteines = - nb de proteines dans @protval\n")
	length(rownames(test@proteins)) == length(unique(test@protval$protein))

#test 3 error
	cat("\n")
	cat("\n")
	factor="protein"
	levels="a1.a3.a1"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(spectral.count, factor=factor, levels=levels)
	cat("\n")
	cat("############# error message expected :\n")
	cat("The levels a1.a3.a1 are not in the factor protein.\n")


#test 3 
	cat("\n")
	cat("\n")
	factor="protein"
	levels="GRMZM2G473001_P01"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(spectral.count, factor=factor, levels=levels)

	cat("\n")
	cat("############# vérification de la cohérence des proteines\n")
	cat("Test: nb de protéines initiales - nb de protéines finales\n")
	length(unique(spectral.count@protval$protein)) - length(unique(test@protval$protein))
	cat("Test: nb de protéines dans @proteines = - nb de proteines dans @protval\n")
	length(rownames(test@proteins)) == length(unique(test@protval$protein))
	
	cat("\n")
	cat("############# vérification de la cohérence des msrun\n")
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@samples))==0
	cat("Test: nb de msrun de @proval - nb de msrun de @samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@samples))==0

#test 4	
	cat("\n")
	cat("\n")
	factor="accession"
	levels="GRMZM2G473001_P01"
	cat(paste("Factor=", factor, ", levels=", levels, sep=""), "\n")
	test=mcq.drop(spectral.count, factor=factor, levels=levels)

	cat("\n")
	cat("############# vérification de la cohérence des proteines\n")
	cat("Test: nb de protéines initiales - nb de protéines finales\n")
	length(unique(spectral.count@protval$protein)) - length(unique(test@protval$protein))
	cat("Test: nb de protéines dans @proteines = - nb de proteines dans @protval\n")
	length(rownames(test@proteins)) == length(unique(test@protval$protein))
	cat("\n")

	cat("\n")
	cat("############# vérification de la cohérence des msrun\n")
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@metadata=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@metadata))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @metadata@samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@metadata@samples))==0
	cat("Test: nb de msrun de @protval - nb de msrun de @samples=0?\n")
	length(unique(test@protval$msrun)) - length(rownames(test@samples))==0

