library("MassChroqR")
packageVersion("MassChroqR")

cat(paste(Sys.time(),"\n",sep =""))

dir.create("/tmp/test_MassChroqR", showWarnings = FALSE)

dir.create("/tmp/test_MassChroqR/test_mcq_get_compar", showWarnings = FALSE)

setwd ("/tmp/test_MassChroqR/test_mcq_get_compar")

cat("Test get compar\n")
cat(" ")   

if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- mcq.read.protpep("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", "/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")

	# import des metadata
	metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")

	# Ajout des metadata a l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}

df=mcq.get.compar(protPep)
if (dim(df)[1]==12295){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (protPep) nb peptiz = 12295  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (protPep) nb peptiz != 12295  \n")
	cat(dim(df)[1])
	cat("\n")
	cat("#####################################\n")
}
if (dim(df)[2]==19){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (protPep) nb samples = 19  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (protPep) nb samples != 19  \n")
	cat(dim(df)[2])
	cat("#####################################\n")
}
head(df)
mcq.write.compar.tsv(protPep, file="df_protPep.tsv")
mcq.write.compar.tsv(protPep, file="df_protPep_id.tsv",sampleid=FALSE)

df= mcq.get.compar(protPep,"extraction")
if (dim(df)[1]==12295){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (protPep) nb peptiz = 12295  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (protPep) nb peptiz != 12295  \n")
	cat(dim(df)[1])
	cat("\n")
	cat("#####################################\n")
}
if (dim(df)[2]==4){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (protPep) level of factor 'extraction' = 4  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (protPep) level of factor 'extraction' != 4  \n")
	cat(dim(df)[2])
	cat("#####################################\n")
}
head(df)

df= mcq.get.compar(protPep,c("extraction","rep"))
if (dim(df)[1]==12295){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (protPep) nb peptiz = 12295  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (protPep) nb peptiz != 12295  \n")
	cat(dim(df)[1])
	cat("\n")
	cat("#####################################\n")
}
if (dim(df)[2]==19){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (protPep) level of combined factors 'extraction-rep' = 19  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (protPep) level of combined factors 'extraction-rep' != 19  \n")
	cat(dim(df)[2])
	cat("#####################################\n")
}
head(df)


pkcount <- mcq.peak.counting(protPep)
df=mcq.get.compar(pkcount)
if (dim(df)[1]==1792){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (pkcount) nb peptiz = 1792  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (pkcount) nb peptiz != 1792  \n")
	cat(dim(df)[1])
	cat("\n")
	cat("#####################################\n")
}
if (dim(df)[2]==19){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (pkcount) nb samples = 19  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (pkcount) nb samples != 19  \n")
	cat(dim(df)[2])
	cat("#####################################\n")
}

head(df)
mcq.write.compar.tsv(pkcount, file="df_pkcount.tsv")
mcq.write.compar.tsv(pkcount, file="df_pkcount_id.tsv",sampleid=FALSE)


# mcq.anova (modele glm)
pkcount.anova = mcq.anova(pkcount, 'extraction')
cat(" ")   
cat("df pkcount.anova (modele glm)\n")
df=mcq.get.compar(pkcount.anova)
if (dim(df)[1]==1792){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (pkcount.anova) nb prot = 1792  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (pkcount.anova) nb prot != 1792  \n")
	cat(dim(df)[1])
	cat("\n")
	cat("#####################################\n")
}
if((length(which(df$model=="Valid"))+length(which(df$model=="Not valid")))==length(df$model)){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (pkcount.anova) \n")
	cat("  model Valid + model Non valid = nb model OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (pkcount.anova) \n")
	cat("  model Valid + model Non valid ! = nb model  \n")
	cat("#####################################\n")
}
head(df)
mcq.write.compar.tsv(pkcount.anova, file="df_pkcount_anova_glm.tsv")
mcq.write.compar.tsv(pkcount.anova, file="df_pkcount_anova_glm_id.tsv",sampleid=FALSE)

mcq.write.merge.tsv(pkcount,pkcount.anova,file="df_merge_pkcount_anova_glm.tsv")
mcq.write.merge.tsv(pkcount,pkcount.anova,file="df_merge_pkcount_anova_glm_id.tsv",sampleid=FALSE)

qprot <- mcq.protquantity(protPep)
cat(" ")   
cat("df qprot\n")  
df=mcq.get.compar(qprot)
if (dim(df)[1]==1792){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (qprot) nb prot = 1792  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (qprot) nb prot != 1792  \n")
	cat(dim(df)[1])
	cat("#####################################\n")
}
if (dim(df)[2]==19){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (qprot) nb samples = 19  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (qprot) nb samples != 19  \n")
	cat(dim(df)[2])
	cat("#####################################\n")
}
head(df)
mcq.write.compar.tsv(qprot, file="df_qprot.tsv")
mcq.write.compar.tsv(qprot, file="df_qprot_id.tsv",sampleid=FALSE)

df= mcq.get.compar(qprot,"extraction")
if (dim(df)[1]==1792){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (qprot) nb prot = 1792  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (qprot) nb prot != 1792  \n")
	cat(dim(df)[1])
	cat("#####################################\n")
}
if (dim(df)[2]==4){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (qprot) level of factor 'extraction' = 4  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (qprot) level of factor 'extraction' != 4  \n")
	cat(dim(df)[2])
	cat("#####################################\n")
}
head(df)

df= mcq.get.compar(qprot,"rep")
if (dim(df)[1]==1792){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (qprot) nb prot = 1792  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (qprot) nb prot != 1792  \n")
	cat(dim(df)[1])
	cat("#####################################\n")
}
if (dim(df)[2]==5){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (qprot) level of factor 'rep' = 5  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (qprot) level of factor 'rep' != 5  \n")
	cat(dim(df)[2])
	cat("#####################################\n")
}
head(df)

df= mcq.get.compar(qprot,c("extraction","rep"))
if (dim(df)[1]==1792){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (qprot) nb prot = 1792  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (qprot) nb prot != 1792  \n")
	cat(dim(df)[1])
	cat("#####################################\n")
}
if (dim(df)[2]==19){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (qprot) level of combined factors 'extraction-rep' = 19  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (qprot) level of combined factors 'extraction-rep' != 19  \n")
	cat(dim(df)[2])
	cat("#####################################\n")
}
head(df)


# mcq.anova (modele aov)
qprot.anova <- mcq.anova(qprot, 'extraction')
cat(" ")   
cat("df qprot.anova (modele aov)\n") 
df=mcq.get.compar(qprot.anova)
if (dim(df)[1]==1792){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (qprot.anova) nb prot = 1792  OK \n")
	cat("      \'extraction\' \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (qprot.anova) nb prot != 1792  \n")
	cat("      flist = \'extraction\' \n")
	cat(dim(df)[1])
	cat("#####################################\n")
}
if(length(grep("pval",colnames(df)))==1){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (qprot.anova)  OK \n")
	cat("      nb pval = nb flist  OK \n")
	cat("      flist = \'extraction\' \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (qprot.anova)\n")
	cat("      nb pval != nb flist   \n")	
	cat("      flist = \'extraction\' \n")
	cat("#####################################\n")
}
if(length(grep("padj",colnames(df)))==1){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (qprot.anova)  OK \n")
	cat("      nb padj = nb flist  OK \n")
	cat("      flist = \'extraction\' \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (qprot.anova)\n")
	cat("      nb padj != nb flist \n")
	cat("      flist = \'extraction\' \n")
	cat("#####################################\n")
}
head(df)
mcq.write.compar.tsv(qprot.anova, file="df_qprot_anova_aov.tsv")

mcq.write.merge.tsv(qprot,qprot.anova,file="df_merge_qprot_anova_aov.tsv")
mcq.write.merge.tsv(qprot,qprot.anova,file="df_merge_qprot_anova_aov_id.tsv",sampleid=FALSE)

# mcq.anova (modele aov)
qprot.anova2F <- mcq.anova(qprot, flist=c('extraction','rep'))
cat(" ")   
cat("df qprot.anova2F\n") 
df=mcq.get.compar(qprot.anova2F)
if (dim(df)[1]==1792){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (qprot.anova) nb prot = 1792  OK \n")
	cat("      \'extraction\',\'rep\' \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (qprot.anova) nb prot != 1792  \n")
	cat("      \'extraction\',\'rep\' \n")
	cat(dim(df)[1])
	cat("#####################################\n")
}
if(length(grep("pval",colnames(df)))==3){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (qprot.anova)  OK \n")
	cat("      nb pval OK \n")
	cat("      \'extraction\',\'rep\' \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (qprot.anova)\n")
	cat("      nb pval KO  \n")	
	cat("      \'extraction\',\'rep\' \n")
	cat("#####################################\n")
}
if(length(grep("padj",colnames(df)))==3){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (qprot.anova)  OK \n")
	cat("      nb padj   OK \n")
	cat("      flist = \'extraction\',\'rep\' \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (qprot.anova)\n")
	cat("      nb padj   KO  \n")
	cat("      flist = \'extraction\',\'rep\' \n")
	cat("#####################################\n")
}
head(df)
mcq.write.compar.tsv(qprot.anova2F, file="df_qprot.anova2F_aov.tsv")
mcq.write.compar.tsv(qprot.anova2F, file="df_qprot.anova2F_aov_id.tsv",sampleid=FALSE)

mcq.write.merge.tsv(qprot,qprot.anova2F,file="df_merge_qprot_anova2F_aov.tsv")
mcq.write.merge.tsv(qprot,qprot.anova2F,file="df_merge_qprot_anova2F_aov_id.tsv",sampleid=FALSE)

spectral.count = mcq.read.spectralcounting("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/results_compar_spectra.txt")
metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")
spectral.count = mcq.merge.metadata(spectral.count, metadata)

cat(" ")   
cat("df spectral.count\n") 
df=mcq.get.compar(spectral.count)
if (dim(df)[1]==1792){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (spectral.count) nb prot = 1792  OK \n")
	cat("      \'extraction\',\'rep\' \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (spectral.count) nb prot != 1792  \n")
	cat("     \'extraction\',\'rep\' \n")
	cat(dim(df)[1])
	cat("#####################################\n")
}
if (dim(df)[2]==19){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (spectral.count) nb samples = 19  OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (spectral.count) nb samples != 19  \n")
	cat(dim(df)[2])
	cat("#####################################\n")
}

head(df)
# NB results_compar_spectra.txt plus récent que XIC_result_prot et XIC_result_pep.tsv
mcq.write.compar.tsv(spectral.count, file="df_spectral.count.tsv")
mcq.write.compar.tsv(spectral.count, file="df_spectral.count.tsv",sampleid=FALSE)


# mcq.anova (modele glm)
spectral.count.glm = mcq.anova(spectral.count, "extraction")
cat(" ")   
cat("df spectral.count.glm\n")
df=mcq.get.compar(spectral.count.glm)
if (dim(df)[1]==1792){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (spectral.count.glm) nb prot = 1792  OK \n")
	cat("      flist = \'extraction\' \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (spectral.count.glm) nb prot != 1792  \n")
	cat("      flist = \'extraction\' \n")
	cat(dim(df)[1])
	cat("#####################################\n")
}
if((length(which(df$model=="Valid"))+length(which(df$model=="Not valid")))==length(df$model)){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (spectral.count.glm) \n")
	cat("  model Valid + model Non valid = nb model OK \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (spectral.count.glm) \n")
	cat("  model Valid + model Non valid ! = nb model  \n")
	cat("#####################################\n")
}
if(length(grep("pval",colnames(df)))==1){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (spectral.count.glm)  OK \n")
	cat("      nb pval = nb flist  OK \n")
	cat("      flist = \'extraction\' \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (spectral.count.glm)\n")
	cat("      nb pval != nb flist   \n")	
	cat("      flist = \'extraction\' \n")
	cat("#####################################\n")
}
if(length(grep("padj",colnames(df)))==1){
	cat("\n")
	cat("#####################################\n")
	cat("      mcq.get.compar (spectral.count.glm)  OK \n")
	cat("      nb padj = nb flist  OK \n")
	cat("      flist = \'extraction\' \n")
	cat("#####################################\n")
}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.get.compar (spectral.count.glm)\n")
	cat("      nb padj != nb flist \n")
	cat("      flist = \'extraction\' \n")
	cat("#####################################\n")
}
head(df)
mcq.write.compar.tsv(spectral.count.glm, file="df_spectral.count_anova_glm.tsv")

mcq.write.merge.tsv(spectral.count,spectral.count.glm,file="df_merge_spectral.count_anova_glm.tsv")
mcq.write.merge.tsv(spectral.count,spectral.count.glm,file="df_merge_spectral.count_anova_glm_id.tsv",sampleid=FALSE)

#str(pkcount.anova)
cat(" ")   
cat("write synthesis\n")

mcq.write.synthesis.tsv(spectral.count,spectral.count.glm,pkcount,pkcount.anova,qprot,qprot.anova,file="synthesis.tsv",sampleid=F)


cat("###########################################\n")
cat("                Test get_compar OK                                                             \n ")
cat("              Verifiez fichiers dans /tmp                                                      \n")
cat("###########################################\n")


# test objet non pris en compte
#peptidepca <- mcq.peptide.pca(protPep)
#cat("df peptidepca\n")
#df=mcq.get.compar(peptidepca)

#protlist = mcq.get.protlist(qprot.anova)
#cat("df protlist\n")
#df=mcq.get.compar(protlist)

