library("MassChroqR")
packageVersion("MassChroqR")

dir.create("/tmp/test_MassChroqR",showWarnings = FALSE)

dir.create("/tmp/test_MassChroqR/test_mcq_imputation",showWarnings = FALSE)

setwd ("/tmp/test_MassChroqR/test_mcq_imputation")

cat ("*********************************************\n")
cat("  Test mcq imputation\n")
cat ("*********************************************\n")

# test bad object

badobject=NULL
result <- tryCatch({

			mcq.impute(badobject)
			
		}, warning = function(war) {

			# warning handler picks up where error was generated
			print(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			print(paste("MY_ERROR:  ",err))

			cat("#####################################\n")
			cat (" error message expected OK\n")
			cat("#####################################\n")

			return()

		})


if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- mcq.read.protpep("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", "/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")

	# import des métadata
	metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}

# test object not normalize
result <- tryCatch({

			protPepnona <- mcq.impute(protPep)
			
		}, warning = function(war) {

			# warning handler picks up where error was generated
			print(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			print(paste("MY_ERROR:  ",err))

			cat("#####################################\n")
			cat (" error message expected OK\n")
			cat("#####################################\n")

			return()

		})


# Normalisation par pourcentage
protPep <- mcq.normalize(protPep, method="percent")

cat(" ")   
cat("summary protPep\n")
summary(protPep)

#Création d'un tableau à 2 dimensions 
tprotPep <- mcq.get.compar(protPep)
cat(" ")   
cat("head tprotPep\n")
head(tprotPep)

if(round(100* sum(is.na(tprotPep))/(nrow(tprotPep) * ncol(tprotPep)),6)==5.502451){
	cat("\n")
	cat("#####################################\n")
	cat("      % of missing values before imputation =  5.502451 \n")
	cat(" 		normalize protPep is OK\n")
	cat("#####################################\n")


}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR % of missing values before imputation != 5.502451  \n")
	cat(100* sum(is.na(tprotPep))/(nrow(tprotPep) * ncol(tprotPep)))
	cat("\n")
	cat(" 		normalize protPep is KO\n")
	cat("#####################################\n")

}

# Ecriture des intensités par peptides et par échantillons avec les valeurs manquantes
mcq.write.compar.tsv(protPep, file="protPepna.tsv")

if (file.exists("protPepnona.RData")) {
	load("protPepnona.RData")
} else {
	protPepnona <- mcq.impute(protPep)
	save(protPepnona, file="protPepnona.RData")
}

# Control Number of proteins totally missing in at least one sample after imputation
compte.prot=table(protPepnona@nona$protein,protPepnona@nona$msrun)
bad=compte.prot==0
bad.prot=apply(bad,1,sum)
n.dmq=bad.prot[bad.prot>0]

if(length(n.dmq)==5){
	cat("\n")
	cat("#####################################\n")
	cat("      Number of proteins totally missing in at least one sample = 5 \n")
	cat("      Imputation is OK\n")
	cat("#####################################\n")


}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR Number of proteins totally missing in at least one sample = 5  \n")
	cat(length(n.dmq)==5)
	cat("\n")
	cat(" 		imputation is KO\n")
	cat("#####################################\n")

}


cat(" ")   
cat("summary protPepnona\n")
summary(protPepnona)

#Création d'un tableau à 2 dimensions 
tprotPepnona <- mcq.get.compar(protPepnona)
cat(" ")   
cat("head tprotPepnona\n")
head(tprotPepnona)

if(round(100* sum(is.na(tprotPepnona))/(nrow(tprotPepnona) * ncol(tprotPepnona)),6)==0.017123){
	cat("\n")
	cat("#####################################\n")
	cat("      % of missing values after imputation =  0.017123 \n")
	cat(" 		imputation is OK\n")
	cat("#####################################\n")


}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR % of missing values after imputation != 0.017123  \n")
	cat(100* sum(is.na(tprotPepnona))/(nrow(tprotPepnona) * ncol(tprotPepnona)))
	cat("\n")
	cat(" 		imputation is KO\n")
	cat("#####################################\n")

}

if(dim(tprotPepnona)[1]==12295){
	cat("\n")
	cat("#####################################\n")
	cat("      Nb of peptiz =  12295 \n")
	cat(" 		imputation is OK\n")
	cat("#####################################\n")


}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR Nb of peptiz !=  12295  \n")
	cat(dim(tprotPepnona)[1])
	cat("\n")
	cat(" 		imputation is KO\n")
	cat("#####################################\n")

}

if(dim(tprotPepnona)[2]==19){
	cat("\n")
	cat("#####################################\n")
	cat("      Nb of samples =  19 \n")
	cat(" 		imputation is OK\n")
	cat("#####################################\n")


}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR Nb of samples !=  19  \n")
	cat(dim(tprotPepnona)[2])
	cat("\n")
	cat(" 		imputation is KO\n")
	cat("#####################################\n")

}

# Ecriture des intensités par peptides et par échantillons avec valeurs imputées
mcq.write.compar.tsv(protPepnona, file="protPepnona.tsv")


cat ("*********************************************\n")
cat (" if KO  : ctrl files in /tmp\n")
cat ("*********************************************\n")



