library("MassChroqR")
packageVersion("MassChroqR")
cat(paste(Sys.time(),"\n",sep =""))

dir.create("/tmp/test_MassChroqR", showWarnings = FALSE)

dir.create("/tmp/test_MassChroqR/test_mcq_metadata", showWarnings = FALSE)

setwd ("/tmp/test_MassChroqR/test_mcq_metadata")

cat("Test mcq_metadata\n")
cat("\n")   

	protPep <- mcq.read.protpep("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", "/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")

cat("#####################################\n")
cat("      summary of protPep \n")
cat(summary(protPep))
cat("\n")
cat("#####################################\n")

# export of metadata

mcq.export.metadata.template(protPep, file="metadata.txt")

	cat("\n")
	cat("#####################################\n")
	cat("      export metadata   OK \n")
	cat("#####################################\n")

# import of metadata
metadata.info <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")

if (nrow(metadata.info@metadata) ==length(unique(protPep@peptides$msrun))){
	cat("\n")
	cat("#####################################\n")
	cat("      nrow of metadata = nb msrun   OK \n")
	cat("#####################################\n")
}

# Ajout des metadata a l'objet protPep
protPep <- mcq.merge.metadata(protPep, metadata.info)

	cat("\n")
	cat("#####################################\n")
	cat("      merge metadata   OK \n")
	cat("#####################################\n")

	cat("\n")
	cat("#####################################\n")
	cat("      error test 1 : bad metadata file \n")
	result <- tryCatch({

			metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/badmetadata.ods")
			
		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat("#####################################\n")
			cat (" error message expected OK\n")
			cat("#####################################\n")

			return()

		})

	cat("#####################################\n")

