library("MassChroqR")
packageVersion("MassChroqR")

cat(paste(Sys.time(),"\n",sep =""))

dir.create("/tmp/test_MassChroqR")

dir.create("/tmp/test_MassChroqR/test_mcq_plot_heatmap")

setwd ("/tmp/test_MassChroqR/test_mcq_plot_heatmap")

cat("Test test_mcq_plot_heatmap\n")

if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- mcq.read.protpep("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", "/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")
	#protPep <- mcq.read.protpep('/gorgone/pappso/formation/Decembre2014/XIC_result_prot.tsv', '/gorgone/pappso/formation/Decembre2014/XIC_result_pep.tsv')


	# import des métadata
	metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")
	#metadata <- mcq.read.metadata('/gorgone/pappso/formation/Decembre2014/metadata.ods')

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}

#test message
result <- tryCatch({

		mcq.plot.heatmap(protPep,file="heatmap_pk_signif_1colors.pdf",factorToColor="extraction")

		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat ("*********************************************\n")
			cat (" error message expected : the class is not taken into account by mcq.plot.heatmap.\n")
			cat ("*********************************************\n")

			return()

		})

if (file.exists("pkcount.RData")) {
	load("pkcount.RData")
} else {
	pkcount <- mcq.peak.counting(protPep)
	save(pkcount, file="pkcount.RData")
}

mcq.plot.heatmap(pkcount,file="heatmap_pk.pdf",cexCol=0.4)
cat ("*********************************************\n")
cat (" warning message expected : Your dataset contains 651 out of 1792 proteins that have no variability.These proteins are not represented on the heatmap.\n")
cat ("*********************************************\n")

result <- tryCatch({

	mcq.plot.heatmap(pkcount,file="heatmap_pk.pdf",flist="sample")

		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat ("*********************************************\n")
			cat (" Error message expected : factor sample is not described in your metadata available factors are : extraction, rep, rep.bis\n")
			cat ("*********************************************\n")

			return()

		})

result <- tryCatch({

	mcq.plot.heatmap(pkcount,file="heatmap_pk.pdf",factorToColor="extraction")

		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat ("*********************************************\n")
			cat (" Error message expected : The factors chosen for factorToColor are not in agreement with those selected for flist.\n")
			cat ("*********************************************\n")

			return()

		})

result <- tryCatch({

	 mcq.plot.heatmap(pkcount,file="heatmap_pk.pdf",flist="extraction",factorToColor=c("extraction","rep"))

		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat ("*********************************************\n")
			cat (" Error message expected : Too many factors chosen for factorToColor (extraction), please choose one in: extraction\n")
			cat ("*********************************************\n")

			return()

		})



if (file.exists("pkcount.anova.RData")) {
	load("pkcount.anova.RData")
} else {
	pkcount.anova <- mcq.anova(pkcount,"extraction") 
	save(pkcount.anova, file="pkcount.anova.RData")
}

mcq.plot.heatmap(pkcount.anova,file="heatmap_pk_anova.pdf",flist="extraction",factorToColor="extraction")
cat ("*********************************************\n")
cat (" warning message expected : Your dataset contains 651 out of 1792 proteins that have no variability.These proteins are not represented on the heatmap.\n")
cat ("*********************************************\n")


if (file.exists("pkcount.anova.signif.RData")) {
	load("pkcount.anova.signif.RData")
} else {
	pkcount.anova.signif <- mcq.select.anova.signif(pkcount.anova, pvalue=0.01,factor="extraction")
	save(pkcount.anova.signif, file="pkcount.anova.signif.RData")
}

#test message
result <- tryCatch({

		mcq.plot.heatmap(pkcount.anova.signif,file="heatmap_pk_signif_1colors.pdf",factorToColor="extraction")

		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat ("*********************************************\n")
			cat (" error message expected : The factors chosen for factorToColor are not in agreement with those selected for flist.\n")
			cat ("*********************************************\n")

			return()

		})

#test message
result <- tryCatch({

		mcq.plot.heatmap(pkcount.anova.signif,file="heatmap_pk_test2.pdf",flist="mutant")

		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat ("*********************************************\n")
			cat (" error message expected : factor mutant is not described in your metadata available factors are : extraction, rep, rep.bis\n")
			cat ("*********************************************\n")

			return()

		})


mcq.plot.heatmap(pkcount.anova.signif,file="heatmap_pk_signif_1flist.pdf", flist="extraction",cexRow=0.4)

mcq.plot.heatmap(pkcount.anova.signif,file="heatmap_pk_signif_2flist.pdf", flist=c("extraction","rep"),cexRow=0.4)

mcq.plot.heatmap(pkcount.anova.signif,file="heatmap_pk_signif_2flist_color.pdf", flist=c("extraction", "rep"), factorToColor="extraction",cexRow=0.4)

# pas joli et sans intérêt
mcq.plot.heatmap(pkcount.anova.signif,file="heatmap_pk_signif_flist_color.pdf", flist=c("extraction", "rep"), factorToColor=c("extraction","rep"),cexRow=0.4)

# différentes méthodes
mcq.plot.heatmap(pkcount.anova.signif,file="heatmap_pk_signif_2flist_color_ward.pdf", flist=c("extraction","rep"),factorToColor="extraction", cexRow=0.4,method="ward")
mcq.plot.heatmap(pkcount.anova.signif,file="heatmap_pk_signif_2flist_color_single.pdf", flist=c("extraction","rep"),factorToColor="extraction", cexRow=0.4,method="single")
mcq.plot.heatmap(pkcount.anova.signif,file="heatmap_pk_signif_2flist_color_complete.pdf", flist=c("extraction","rep"),factorToColor="extraction", cexRow=0.4,method="complete")
mcq.plot.heatmap(pkcount.anova.signif,file="heatmap_pk_signif_2flist_color_mcquitty.pdf", flist=c("extraction","rep"),factorToColor="extraction", cexRow=0.4,method="mcquitty")
mcq.plot.heatmap(pkcount.anova.signif,file="heatmap_pk_signif_2flist_color_median.pdf", flist=c("extraction","rep"),factorToColor="extraction", cexRow=0.4,method="median")
mcq.plot.heatmap(pkcount.anova.signif,file="heatmap_pk_signif_2flist_color_centroid.pdf", flist=c("extraction","rep"),factorToColor="extraction", cexRow=0.4,method="centroid")


cat ("*********************************************\n")
cat ("heatmap test is OK for pkcount \n")
cat ("*********************************************\n")


if (file.exists("protq.RData")) {
	load("protq.RData")
} else {
	qprot <- mcq.protquantity(protPep)
	save(qprot, file="protq.RData")
}

result <- tryCatch({

		mcq.plot.heatmap(qprot,file="heatmap_pk_signif_1colors.pdf",factorToColor="extraction")

		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat ("*********************************************\n")
			cat (" error message expected : The factors chosen for factorToColor are not in agreement with those selected for flist.\n")
			cat ("*********************************************\n")

			return()

		})

mcq.plot.heatmap(qprot,file="heatmap_XIC_signif_1colors.pdf",factorToColor="extraction",flist="extraction")

cat ("*********************************************\n")
cat ("heatmap test is OK for qprot \n")
cat ("*********************************************\n")





