
# chargement du paquet
library("MassChroqR")
packageVersion("MassChroqR")
cat("\n")

#
dir.create("/tmp/test_MassChroqR", showWarnings = FALSE)
dir.create("/tmp/test_MassChroqR/test_mcq_protlist", showWarnings = FALSE)

setwd ("/tmp/test_MassChroqR/test_mcq_protlist")

if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- mcq.read.protpep("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", "/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")

	# import of metadata
	metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")

	# add metadata to protPep object
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}


cat("\n")
cat("#####################################\n")
cat("      function mcq.protlist \n")
cat("#####################################\n")

sublist = mcq.protlist(c("GRMZM2G041275_P01", "ARABIDO", "GRMZM2G097457_P01"))
cat("\n")
cat("#####################################\n")
cat("     str(sublist) \n")
cat(str(sublist))
cat("\n")
cat("#####################################\n")


cat("\n")
cat("#####################################\n")
cat("      function mcq.get.protlist \n")
cat("#####################################\n")

listProt <- mcq.get.protlist(protPep)

if(length(listProt@proteins)==1792){
	cat("\n")
	cat("#####################################\n")
	cat("      nb prot = 1792  OK \n")
	cat("#####################################\n")

}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR nb prot != 1792  \n")
	cat(length(listProt@proteins))
	cat("\n")
	cat("#####################################\n")

	stop ("error")
}

write.table(listProt@proteins,"listProt.tsv", quote= FALSE,  sep="\t", dec=".",row=F)

cat("\n")
cat("#####################################\n")
cat("      function mcq.grep.protlist \n")
cat("#####################################\n")

protlist.GRMZM2G = mcq.grep.protlist(listProt, "GRMZM2G")

if(length(protlist.GRMZM2G@proteins)==1614){
	cat("\n")
	cat("#####################################\n")
	cat("      nb prot = 1614  OK \n")
	cat("#####################################\n")

}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR nb prot != 1614  \n")
	cat(length(protlist.GRMZM2G@proteins))
	cat("\n")
	cat("#####################################\n")

	stop ("error")
}


cat("\n")
cat("#####################################\n")
cat("      function mcq.drop.protlist \n")
cat("#####################################\n")


listProtdrop = mcq.drop.protlist(listProt, sublist)

if(length(listProtdrop@proteins)==1790){
	cat("\n")
	cat("#####################################\n")
	cat("      nb prot = 1790  mcq.drop.protlist OK \n")
	cat("#####################################\n")

}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR nb prot != 1790  mcq.drop.protlist \n")
	cat(length(listProtdrop@proteins))
	cat("\n")
	cat("#####################################\n")

	stop ("error mcq.drop.protlist")
}

cat("\n")
cat("#####################################\n")
cat("      function mcq.select.protlist \n")
cat("#####################################\n")


listProtselect = mcq.select.protlist(listProt, sublist)

if(length(listProtselect@proteins)==2){
	cat("\n")
	cat("#####################################\n")
	cat("      nb prot = 2  mcq.select.protlist OK \n")
	cat("#####################################\n")

}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR nb prot != 2  mcq.select.protlist \n")
	cat(length(listProtselect@proteins))
	cat("\n")

	cat("#####################################\n")

	stop ("error mcq.select.protlist")
}


cat ("*********************************************\n")
cat (" mcq.protlist OK\n")
cat (" ctrl listProt.tsv in /tmp and run Rscript test_pairwise_test_prot.R \n")
cat ("*********************************************\n")
