library("MassChroqR")

cat(paste(Sys.time(),"\n",sep =""))
packageVersion("MassChroqR")
cat("\n")

dir.create("/tmp/test_MassChroqR", showWarnings = FALSE)

dir.create("/tmp/test_MassChroqR/test_mcq_read_prot_pep", showWarnings = FALSE)

setwd ("/tmp/test_MassChroqR/test_mcq_read_prot_pep")

cat("Test mcq_read_prot_pep\n")

protPep <- mcq.read.protpep("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", "/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")

if (dim(protPep@proteins)[1]==12901) {
	cat("#####################################\n")
	cat("		nb prot in protpep = 12901  OK \n")
	cat("#####################################\n")
}else{
	cat("#####################################\n")
	cat("		ERROR nb prot != 12901  \n")
	cat(dim(protPep@proteins)[1])
	cat("\n")
	cat("#####################################\n")
}
if (dim(protPep@proteins)[2]==4) {
	cat("#####################################\n")
	cat("		nb prot in protpep = 4  OK \n")
	cat("#####################################\n")
}else{
	cat("#####################################\n")
	cat("		ERROR nb prot != 4  \n")
	cat(dim(protPep@proteins)[2])
	cat("\n")
	cat("#####################################\n")
}
if (dim(protPep@peptides)[1]==220751) {
	cat("#####################################\n")
	cat("		nb peptides in protpep = 220751  OK \n")
	cat("#####################################\n")
}else{
	cat("#####################################\n")
	cat("		ERROR nb prot != 220751  \n")
	cat(dim(protPep@peptides)[1])
	cat("\n")
	cat("#####################################\n")
}
if (dim(protPep@peptides)[2]==16) {
	cat("#####################################\n")
	cat("		nb peptides  in protpep = 16  OK \n")
	cat("#####################################\n")
}else{
	cat("#####################################\n")
	cat("		ERROR nb prot != 16  \n")
	cat(dim(protPep@peptides)[2])
	cat("\n")
	cat("#####################################\n")
}

# test presence of apostrophes
result <- tryCatch({

			protPep <- mcq.read.protpep("/gorgone/pappso/jouy/users/Anne/Analyses-Data2016/20160816_Proteocardis/20160816_GP_proteocardis_list_tot_prot.tsv", "/gorgone/pappso/formation/Decembre2014/XIC_result_pep.tsv")

		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat ("*********************************************\n")
			cat (" error message expected OK\n")
			cat ("*********************************************\n")

			return()

		})

