################################################################################

# MassChroqR

# chargement du paquet 
library("MassChroqR")
packageVersion("MassChroqR")
cat(paste(Sys.time(),"\n",sep =""))
cat("\n")

################################################################################

# repertoire temporaire ou de travail
dir.create("/tmp/test_MassChroqR", showWarnings = FALSE)

dir.create("/tmp/test_MassChroqR/test_mcq_spectralcounting", showWarnings = FALSE)

setwd ("/tmp/test_MassChroqR/test_mcq_spectralcounting")

cat ("*********************************************\n")
cat("Test mcq spectralcounting\n")
cat ("*********************************************\n")

cat("\n")   

################################## Recuperation des informations de Spectral Counting 
# Pour eventuellement merger les donnees de Spectral Counting, Peak counting et XIC
# ATTENTION pour l'instant preparer la feuille comparspectra dans un fichier csv (bug read.ods pour fichier avec plusieurs onglets)
# since v0.3.3 
cat("\n")   
cat(" * Recuperation des informations de Spectral Counting \n") 


#### lecture fichier comparspectra
if (file.exists("compar_spectra.txt")) {
	spectral.count = mcq.read.spectralcounting("compar_spectra.txt")
}else{
	spectral.count = mcq.read.spectralcounting("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/results_compar_spectra.txt")
}
 
#### lecture fichier metadata
if (file.exists("metadata.ods")) {
  # import des métadata
	metadata <- mcq.read.metadata("metadata.ods")
}else{
  # export d'un template dans lequel pourront etre ajoutees les metadata
  #mcq.write.metadata.tsv(protPep, 'metadata.tsv')
  #stop("complete metadata.tsv and save in ods format")
	metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")
}

# merge avec les metadata
spectral.count = mcq.merge.metadata(spectral.count, metadata)
cat("\n")   
cat("summary spectral.count \n")   
summary(spectral.count)

#selection du jeu de donnees
#cat("\n")   
#cat(" * Selection du jeu de donnees \n") 
#cat(" supprime 'samp0','samp1','samp10','samp11','samp12','samp13','samp14','samp15','samp16','samp17','samp18','samp19','samp2','samp20','samp21','samp22','samp23','samp6','samp7','samp8','samp9'\n") 

#spectral.count <-  mcq.drop(spectral.count, 'msrun',c('samp0','samp1','samp10','samp11','samp12','samp13','samp14','samp15','samp16','samp17','samp18','samp19','samp2','samp20','samp21','samp22','samp23','samp6','samp7','samp8','samp9'))

#########################################################################
# Statistique decisionnelle sur les donnees de 'Spectral counting'
# pour tableau final : test sur totalite
cat("\n ")   
cat("spectral.count anova \n")   
spectral.count.anova = mcq.anova(spectral.count,"extraction")

if ((nrow(spectral.count@proteins)==1792)&&(nrow(spectral.count@protval)==34048)&&(nrow(spectral.count@samples)==19)){
	cat("###########################################\n")
	cat("                Test mcq spectralcounting OK                                                             \n ")
	cat("###########################################\n")
}else{
	cat ("*********************************************\n")
	cat (paste(" spectral.count@proteins : ", nrow(spectral.count@proteins)," (waited 1792)\n",sep=""))
	cat (paste(" spectral.count@protval : ", nrow(spectral.count@protval)," (waited 34048)\n",sep=""))
	cat (paste(" spectral.count@samples : ", nrow(spectral.count@samples)," (waited 19)\n",sep=""))
	cat ("*********************************************\n")
}
