library("MassChroqR")
packageVersion("MassChroqR")

cat(paste(Sys.time(),"\n",sep =""))

dir.create("/tmp/test_MassChroqR", showWarnings = FALSE)

dir.create("/tmp/test_MassChroqR/test_pairwise_test_prot", showWarnings = FALSE)

setwd ("/tmp/test_MassChroqR/test_pairwise_test_prot")

cat("Test pairwise_test_prot\n")


if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- mcq.read.protpep("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", "/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")

	# import des métadata
	metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}

if (file.exists("protq.RData")) {
	load("protq.RData")
} else {
	qprot <- mcq.protquantity(protPep)
	save(qprot, file="protq.RData")
}


ttest <- mcq.pairwise.t.test(qprot, "extraction")

#cat ("head ttest@restest$pair.result\n")
#head(ttest@restest$pair.result)

#head (ttest@proteins)
protselect.nona <- mcq.get.protlist(ttest, fdr=0.05)

#head (protselect.nona@proteins)
if(length(protselect.nona@proteins)==1481){
	cat("\n")
	cat("#####################################\n")
	cat("      nb prot = 1481  OK \n")
	cat("#####################################\n")

}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR nb prot != 1481  \n")
	cat(length(protselect.nona@proteins))
	cat("\n")
	cat("#####################################\n")

}

# test pair
cat(" \n" )
cat("test pair : teal urzb\n" )

#ttest@restest$pair.result

protselect.nona <- mcq.get.protlist(ttest, fdr=0.05, pair=c("teal","urzb"))

#head (protselect.nona@proteins)
if(length(protselect.nona@proteins)==1258){
	cat("\n")
	cat("#####################################\n")
	cat("      nb prot = 1258  OK \n")
	cat(" mcq.get.protlist test pair OK\n")
	cat("#####################################\n")


}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR nb prot != 1258  \n")
	cat(length(protselect.nona@proteins))
	cat("\n")
	cat("#####################################\n")

}



# test reversed pair
cat(" \n" )
cat("test reversed pair : urzb teal \n" )
protselect.nona <- mcq.get.protlist(ttest, fdr=0.05, pair=c("urzb","teal"))

if(length(protselect.nona@proteins)==1258){
	cat("\n")
	cat("#####################################\n")
	cat("      nb prot = 1258  OK \n")
	cat(" mcq.get.protlist test reversed pair OK\n")
	cat("#####################################\n")


}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR nb prot != 1258  \n")
	cat(length(protselect.nona@proteins))
	cat("\n")
	cat("#####################################\n")

}

# test missing pair
result <- tryCatch({

			protselect.nona <- mcq.get.protlist(ttest, fdr=0.05, pair=c("1","2"))

		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat("#####################################\n")
			cat (" error message expected OK\n")
			cat("#####################################\n")

			return()

		})
