library("MassChroqR")
packageVersion("MassChroqR")

cat(paste(Sys.time(),"\n",sep =""))

dir.create("/tmp/test_MassChroqR", showWarnings = FALSE)

dir.create("/tmp/test_MassChroqR/test_plot_ratio", showWarnings = FALSE)

setwd ("/tmp/test_MassChroqR/test_plot_ratio")

cat("Test test_plot_ratio\n")
cat("\n")   

cat("###################################\n")
cat("      test plot ratio                                                                 \n")
cat("###################################\n")
cat("\n")

if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- mcq.read.protpep("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", "/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")

	# import des métadata
	metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}

if (file.exists("qprot.RData")) {
	load("qprot.RData")
} else {
	qprot <- mcq.protquantity(protPep)
	save(qprot, file="qprot.RData")
}
	
if (file.exists("qprot.aov.RData")) {
	load("qprot.aov.RData")
} else {
	# nouvelle fonction anova modele aov 
	cat("nouvelle fonction 1 facteur\n")
	qprot.aov <- mcq.anova(qprot, "extraction")
	save(qprot.aov, file="qprot.aov.RData")
}

	anova.signif <- mcq.select.anova.signif(qprot.aov, 0.01, factor="extraction")
	protlist.signif <- mcq.get.protlist(anova.signif)
	qprot.signif <- mcq.select.protlist(qprot, protlist.signif)


# Display of the graph on the screen
	mcq.plot.ratio(qprot.signif,factor="extraction", numerator="teal", denominator="urnb")

# Export of the graph in a .pdf file in '/path/to/my_working_directory'
	mcq.plot.ratio(qprot.signif,factor="extraction", numerator="teal", denominator="urnb", file="Ratio_signif_5percent.pdf")

# Export of the graph in a .pdf file and the ratios in .txt or .tsv which is equivalent to csv except that the text separator is a tab. The files are saved in '/path/to/my_working_directory'
	mcq.plot.ratio(qprot.signif,factor="extraction", numerator="teal", denominator="urnb", file="Ratio_signif_5percent.pdf", outputfile="ratio.txt")


cat("*********************************************\n")
cat("test is OK \n")
cat("See files in   /tmp/test_MassChroqR/test_plot_ratio                                              \n")
cat("*********************************************\n")
