library("MassChroqR")
packageVersion("MassChroqR")

cat(paste(Sys.time(),"\n",sep =""))

dir.create("/tmp/test_MassChroqR", showWarnings = FALSE)

dir.create("/tmp/test_MassChroqR/test_select_protlist", showWarnings = FALSE)

setwd ("/tmp/test_MassChroqR/test_select_protlist")

cat("Test Select Prolist\n")

if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- mcq.read.protpep("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", "/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")

	# import des métadata
	metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}

if (file.exists("protq.RData")) {
	load("protq.RData")
} else {
	qprot <- mcq.protquantity(protPep)
	save(qprot, file="protq.RData")
}


if (file.exists("ttest.RData")) {
	load("ttest.RData")
} else {
	ttest <- mcq.pairwise.t.test(qprot, "extraction")
	save(ttest, file="ttest.RData")
}

plist = mcq.protlist(c("GRMZM2G139643_P01 NP_001131946 hypothetical protein LOC100193339 seq=translation; coord=4:229898346..229903473:1; parent_transcript=GRMZM2G139643_T01; parent_gene=GRMZM2G139643",
				"GRMZM2G140116_P01 NP_001131498 hypothetical protein LOC100192835 seq=translation; coord=2:197230836..197232295:1; parent_transcript=GRMZM2G140116_T01; parent_gene=GRMZM2G140116"
				, "GRMZM2G004111_P01 B6TW91 Putative uncharacterized protein seq=translation; coord=8:169891088..169891851:-1; parent_transcript=GRMZM2G004111_T01; parent_gene=GRMZM2G004111"
				,
				"GRMZM2G001898_P01 NP_001142146 hypothetical protein LOC100274311 seq=translation; coord=7:13844415..13850805:1; parent_transcript=GRMZM2G001898_T01; parent_gene=GRMZM2G001898"
		))

protPep.minus <- mcq.select.protlist(protPep, plist)

cat("\n")   
cat("Summary protPep.minus \n")
summary(protPep.minus)

if (length(protPep.minus@proteins)==4) {
	cat("#####################################\n")
	cat("		nb prot in protlist = 4  OK \n")
	cat("#####################################\n")
}else{
	cat("#####################################\n")
	cat("		ERROR nb prot != 4  \n")
	cat(length(protlist@proteins))
	cat("\n")
	cat("#####################################\n")
}

mcq.write.compar.tsv(protPep.minus, "peptide_minus.tsv")


#chicken = mcq.protlist(c("sp|P01012|OVAL_CHICK"))
#protPep_chicken <- mcq.select.protlist(protPep, chicken)
#summary(protPep_chicken)
#mcq.write.compar.tsv(protPep_chicken, 'peptide_chicken.tsv')

cat("\n")   
cat("summary protPep\n")
summary(protPep)

protlist = mcq.get.protlist(protPep)
if (length(protlist@proteins)==1792) {
	cat("#####################################\n")
	cat("		nb prot in protlist = 1792  OK \n")
	cat("#####################################\n")
}else{
	cat("#####################################\n")
	cat("		ERROR nb prot != 1792  \n")
	cat(length(protlist@proteins))
	cat("\n")
	cat("#####################################\n")
}

cat("\n")   
cat("test selection with grep GRMZM2G\n")

protlist.GRMZM2G = mcq.grep.protlist(protlist, "GRMZM2G")
protPep.GRMZM2G = mcq.select.protlist(protPep, protlist.GRMZM2G)

cat("\n")   
cat("summary protPep.GRMZM2G\n")
summary(protPep.GRMZM2G)

if (length(protlist.GRMZM2G@proteins)==1614) {
	cat("#####################################\n")
	cat("		nb prot GRMZM2G in protlist = 1614  OK \n")
	cat("#####################################\n")
}else{
	cat("#####################################\n")
	cat("		ERROR nb prot GRMZM2G != 1614  \n")
	cat(length(protlist.GRMZM2G@proteins))
	cat("\n")
	cat("#####################################\n")
}


cat("\n")   
cat("test select protlist on T test\n")
protselect.nona <- mcq.get.protlist(ttest, fdr=0.05)

cat("\n")   
cat("summary protselect.nona\n")
summary(protselect.nona)

if (length(protselect.nona@proteins)==1481) {
	cat("#####################################\n")
	cat("		nb prot in protselect.nona = 1481  OK \n")
	cat("#####################################\n")
}else{
	cat("#####################################\n")
	cat("		ERROR nb protselect.nona != 1481  \n")
	cat(length(protselect.nona@proteins))
	cat("\n")
	cat("#####################################\n")
}



cat("###########################################\n")
cat("                Test  OK   Select Prolist                                                          \n ")
cat("              Verifiez fichier Result_test.txt dans /tmp/ test_MassChroqR/test_select_protlist     \n")
cat("###########################################\n")
