mcq.drop.uncorrelated.peptides<- function (object, factorName, min.corr = 0.75) {
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {
		if (factorName %in% colnames(object@metadata@metadata)) {

		}
		else {
			stop(paste("the factor ",factorName," is not described in your metadata"))
		}
		warnlognorm <- FALSE
		if("lognorm" %in% colnames(object@peptides)) {

		}else {
			warnlognorm <- TRUE
			warning(paste("data are not normalized in \"", class(object),"\" object",sep=""))
			#stop("mcqProtPep object is not normalized")
			object@peptides$lognorm <- object@peptides$logarea
		}
		if (length(unique(object@metadata@metadata[,factorName])) < 3) {
			stop(paste("the factor ",factorName," should at least have 3 or more states to process correlations"))
		}

		# on a maintenant besoin que tabok contienne les données de traitement
		# juste bidouille parce qu'on traine toujours à la fois msrun et msrunfile, il faudra s'en débarasser.
		#tabok=tabok[,-which(colnames(tabok)=="msrunfile"]
		#tabok=merge(tabok, traitement,by="msrun")
		#tabok=drop.levels(tabok) # par sécurité. eEn principe non nécessaire.

		proteins <- unique(object@proteins$protein)
		nbprot <- length(proteins)

		cat(paste("Nb de protéines avant sélection par les corrélations:",length(proteins),"\n"))
		pepoktot=NULL
		for (i in 1:nbprot){
			bestPepCorr <- privcorrpept(object, factorName, proteins[i],min.corr)
			#print (bestPepCorr)
			if (!is.null(bestPepCorr)) {
				pepoktot=c(pepoktot,bestPepCorr)
			}
			if (i%%100==0) cat(paste("looking for best corr peptides for protein ",i," out of ",nbprot,"\n"))
		}

		if (warnlognorm) {
			object@peptides$lognorm <- NULL
		}
		object@peptides <- object@peptides[object@peptides$peptiz %in% pepoktot,]
		#object@peptides <- drop.levels(object@peptides)

		pepok <- unique(object@peptides$peptide)
		object@proteins <- object@proteins[object@proteins$peptide %in% pepok,]
		#object@proteins <- drop.levels(object@proteins)

		cat(paste("Nb de peptiz après sélection par les corrélations:",length(unique(object@peptides$peptiz)),"\n"))
		cat(paste("Nb de protéines après sélection par les corrélations:",length(unique(object@proteins$protein)),"\n"))

		#save(tabok,file="tabokpep.RData")

		return (object)

	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcqDropUncorrelatedPeptides",sep=""))
	}
}

mcq.drop.uncorrelated.peptides.new<- function (object, flist=NULL, rCutoff = 0.5, pvalCutoff=1) {
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {
		if (sum(!flist %in% colnames(object@metadata@metadata))>0) {
			stop(paste("The factor ", flist[!flist %in% colnames(object@metadata@metadata)]," is not described in your metadata."))
		}

		if("lognorm" %in% colnames(object@peptides)) {
			warnlognorm <- FALSE
		}else{
			warnlognorm <- TRUE
			cat(paste("Intensities are not normalized in the input object of class.", class(object) , "\n", sep=""))
		}

		# creaction of combiFact
		if (length(flist)==1){
			combiFact=object@metadata@metadata[,flist[1]]
		}
		if (length(flist)>1){
			combiFact<-paste(object@metadata@metadata[,flist[1]], object@metadata@metadata[,flist[2]], sep="-")
			if (length(flist)>2){
				for (i in 3:length(flist)){
					combiFact<-paste(test, object@metadata@metadata[,flist[i]], sep="-")
				}
			}
		}	

		if (length(combiFact) < 5) {
			stop(paste("The factor or the combination of factors chosen for flist should have at least 5 levels."))
		}

		meta=cbind.data.frame(object@metadata@metadata,combiFact=combiFact )

		proteins <- unique(object@proteins$protein)
		nbprot.before <- length(proteins)
		nb.pepz.before <- length(unique(object@peptides$peptiz))
		nb.pep.before <- length(unique(object@peptides$peptide))

		# computing correlations
		pepoktot=NULL
		for (i in 1:nbprot.before){
			subprot <- object@proteins[object@proteins$protein==proteins[i],]
			if (warnlognorm == FALSE){
				sub <- object@peptides[object@peptides$peptide %in% subprot$peptide,c("msrun","lognorm","peptiz")]
				sub <- merge(sub, meta, by.x="msrun", by.y="row.names")
				toto=tapply(sub$lognorm,list(sub[,"combiFact"],as.character(sub$peptiz)),FUN=mean,na.rm=T)
			}else{
				sub <- object@peptides[object@peptides$peptide %in% subprot$peptide,c("msrun","logarea","peptiz")]
				sub <- merge(sub, meta, by.x="msrun", by.y="row.names")
				toto=tapply(sub$logarea,list(sub[,"combiFact"],as.character(sub$peptiz)),FUN=mean,na.rm=T)
			}

			if(ncol(toto)>1){

				cor.cal=rcorr(as.matrix(toto), type="pearson")

				diag(cor.cal$r)=NA
				tab.r=stack(as.data.frame(cor.cal$r))
				colnames(tab.r)=c("r", "pep1")
				tab.r$pep1=as.character(tab.r$pep1)
				tab.r$pep2=rep(rownames(cor.cal$r), ncol(cor.cal$r))
				tab.p=stack(as.data.frame(cor.cal$P))
				tab.r$pval=tab.p[,1]
				tab.n=stack(as.data.frame(cor.cal$n))
				tab.r$pval=tab.p[,1]
				tab.r=na.omit(tab.r)

				# looking for ref.pep= peptides with the highest nb of coefficients of correlation superior or equal to the mean of the positives coefficients of correlation			
				if (!is.na(rmean)){	
					rmean=mean(tab.r$r[tab.r$r>0])
					best.cor=tab.r[tab.r$r>=rmean,]
					best.cor=na.omit(best.cor)
					count=table(best.cor$pep1)
					ref.pep.temp=names(count[count==max(count)])
					rmean.pep=tapply(best.cor$r, list(best.cor$pep1), mean)
					rmean.pep=rmean.pep[names(rmean.pep) %in% ref.pep.temp]
					ref.pep=names(rmean.pep[rmean.pep==max(rmean.pep)])[1]
					tab.ref.pep=tab.r[tab.r$pep1==ref.pep,]

					# picking up good peptiz	
					pepoktot=c(pepoktot, ref.pep, tab.ref.pep$pep2[tab.ref.pep$r>rCutoff & tab.ref.pep$pval<pvalCutoff])
				}
			}

			if (i%%100==0) cat(paste("Dropping uncorrelated peptides-modification-charge for protein ",i," out of ",nbprot.before,"\n"))
		}

		object@peptides <- object@peptides[object@peptides$peptiz %in% pepoktot,]
		pepok <- unique(object@peptides$peptide)
		object@proteins <- object@proteins[object@proteins$peptide %in% pepok,]

		nbprot.after <- length(unique(object@proteins$protein))
		nb.pepz.after <- length(unique(object@peptides$peptiz))
		nb.pep.after <- length(unique(object@peptides$peptide))

		cat(paste((nb.pepz.before-nb.pepz.after), " peptides-modification-charge dropped, \n", sep=""))
		cat(paste("corresponding to ", (nb.pep.before-nb.pep.after), " peptides,\n", sep=""))
		cat(paste("corresponding to ", (nbprot.before-nbprot.after), " proteins,\n", sep=""))

		return (object)

	}
	else {
		stop(paste("The class ", class(object), " of the input object is not taken into account by mcq.drop.uncorrelated.peptides",sep=""))
	}
}






	

