


mcq.drop.unreproducible.peptides<- function (object, method="percent", percentCutoff=0.1, flist=NULL, repFactor=NULL, repFactorCutoff=NULL, flistCutoff=NULL) {
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {
		nbsample=length(unique(object@peptides$msrun))
		nbpeptiz.before=length(unique(object@peptides$peptiz))

		if (method=="percent"){
			ni <- table(object@peptides$peptiz)
			peptok=names(ni[ni>=floor(nbsample*(1-percentCutoff))])
		}

		if (method=="refined"){
		 # control parameters : flist
			if (is.null(flist)) {
				stop("You must choose a flist\n")
			}else{
				if(sum(!flist %in% colnames(object@metadata@metadata)>0)) {
				stop(paste("The factor ", flist[!flist %in% colnames(object@metadata@metadata)], " chosen for flist is not described in your metadata\n", "please choose one in: ", paste(colnames(object@metadata@metadata),collapse=", "), "\n", sep=""))
				}
			}

 		 # control parameters : repFactor
			if (is.null(repFactor)) {
				stop("You must choose a repFactor\n")
			} else {
				if(sum(!repFactor %in% colnames(object@metadata@metadata)>0)) {
					stop(paste("The factor ", repFactor[!repFactor %in% colnames(object@metadata@metadata)], " chosen for repFactor is not described in your metadata\n", "please choose one in: ", paste(colnames(object@metadata@metadata),collapse=", "), "\n", sep=""))
				}
			}

		  # creaction of combiFact
			if (length(flist)==1){
				combiFact=object@metadata@metadata[,flist[1]]
			}
			if (length(flist)>1){
				combiFact<-paste(object@metadata@metadata[,flist[1]], object@metadata@metadata[,flist[2]], sep="-")
				if (length(flist)>2){
					for (i in 3:length(flist)){
						combiFact<-paste(test, object@metadata@metadata[,flist[i]], sep="-")
					}
				}
			}

		 # compute the number of authorized missing data per sample
			cat(paste("You authorize a peptide-modification-charge to be missing in maximum ", nbsample-(flistCutoff*repFactorCutoff)," samples out of ", nbsample, "\n", sep=""))


			meta=cbind.data.frame(combiFact=combiFact, msrun=rownames(object@metadata@metadata), rep=object@metadata@metadata[,repFactor])
	

			tab.temp=merge(object@peptides, meta, "msrun" )
			count=table(tab.temp$peptiz, tab.temp$combiFact)
			count=count>=repFactorCutoff
			tot=apply(count, 1, sum)
			peptok=names(which(tot>=flistCutoff))
		}

		object@peptides=object@peptides[object@peptides$peptiz %in% peptok,]
		object@proteins <- object@proteins[object@proteins$peptide %in% unique(object@peptides$peptide),]

		nbpeptiz.after=length(unique(object@peptides$peptiz))

		cat(paste((nbpeptiz.before - nbpeptiz.after)," peptides-modif-charge dropped out of ", nbpeptiz.before,"\n"))

		return (object)

	}
	else {
		stop(paste("The class ", class(object), " of the input object is not taken into account by mcq.drop.unreproducible.peptides",sep=""))
	}
}




















