
mcq.plot.peptide.sharing<- function (object,file=NULL) {
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {
		nprot.per.pept=table(object@proteins$peptide)

		if (is.null(file)){
			par(ask=FALSE)
		}
		else{
			pdf(file, title=gsub('.pdf$','',file), width=15)
		}
			par(mfrow=c(1,2))
			H=hist(nprot.per.pept, breaks=c(0:max(nprot.per.pept)), xlab="Number of proteins associated to a peptide", main=c("Distribution of the number of", " proteins per peptide"), ylab="Number of peptides", border="darkblue", axes=FALSE)
			axis(1, at=c(0.5:(max(nprot.per.pept)+1.5)), labels=c(1:(max(nprot.per.pept)+2)))
			axis(2, at=seq(0, round(H$counts[1], -2), round(H$counts[1], -2)/5), labels=seq(0, round(H$counts[1], -2), round(H$counts[1], -2)/5))
			H=hist(nprot.per.pept[!nprot.per.pept==1], breaks=c(1:max(nprot.per.pept[!nprot.per.pept==1])), xlab="Number of proteins associated to a shared peptide", main=c("Distribution of the number of", " proteins per shared peptide"), ylab="Number of shared peptides", border="darkblue", axes=FALSE)
			axis(1, at=c(1.5:(max(nprot.per.pept[!nprot.per.pept==1])+0.5)), labels=c(2:(max(nprot.per.pept[!nprot.per.pept==1])+1)))
			axis(2, at=seq(0, round(H$counts[1], -2), round(H$counts[1], -2)/5), labels=seq(0, round(H$counts[1], -2), round(H$counts[1], -2)/5))

		if (!is.null(file)){
			dev.off()
		}
		par(mfrow=c(1,1))
	}
	else {
		stop(paste("The class ",class(object)," of the input object is not taken into account by mcq.plot.peptide.sharing"))
	}
}
