\name{mcq.drop.shared.peptides}

\alias{mcq.drop.shared.peptides}

\title{Drop Shared Peptides}

\description{This function removes from the proteomic dataset the peptides shared by two or more proteins.}

\usage{mcq.drop.shared.peptides(object)}

\arguments{
	\item{object}{an object of class 'mcqProtPep' or 'mcq.skyline'}
}

\details{This function allows keep the peptide associated to only one protein. These peptides are not necessarily proteotypic peptides. In fact, their are specific of a subgroup of proteins of XTandempipeline.}

\value{The 'mcq.drop.shared.peptides' function returns the input object without the peptides shared by two or more proteins.}

\references{}

\author{}

\note{}

\seealso{'mcq.plot.peptide.sharing'}

\examples{

# Preliminary step: load the example dataset and merge metadata to the object of class 'mcqProtPep'
	data(extraction)
	protPep <- mcq.merge.metadata(protPep, metadata.info)
	
# Remove shared peptides
	protPep.cleaned=mcq.drop.shared.peptides(protPep)
	summary(protPep)
	summary(protPep.cleaned)
}

