\name{mcq.plot.peptide.reproducibility}

\alias{mcq.plot.peptide.reproducibility}

\title{Plot Peptide Reproducibility}

\description{This function draws two graphs: a histogram for the distribution of the number of samples in which a peptide-modification-charge is quantified and a plot showing the number of peptides-modification-charge and the number of proteins depending on the strength of a filter based on the minimal proportion of samples in which a peptide-modification-charge must be present to be considered as valid.}

\usage{mcq.plot.peptide.reproducibility(object, file=NULL)}

\arguments{
    \item{object}{an object of class 'mcq.peakcounting' or 'mcq.spectralcounting'}
    \item{file}{a character vector indicating the name of the pdf file where to export the graphs (e.g. "mygraph.pdf"). By default, the graphs are displayed on the screen} 
}

\details{}

\value{The function 'mcq.plot.peptide.reproducibility' returns two graphs that are displayed on the screen when the pdf argument is NULL or that are exported as a pdf file when the pdf argument is filled in.}

\references{}

\author{}

\note{}


\seealso{}

\examples{
# Preliminary step: load the example dataset and compute the protein abundances as the number of chromatographic peaks
	data(extraction)
	pkcount <- mcq.peak.counting(protPep)

# Launch the 'mcq.plot.peaks.per.sample' function
	mcq.plot.counts.per.sample(pkcount)
}
 
