\name{mcq.plot.peptide.sharing}

\alias{mcq.plot.peptide.sharing}

\title{Proteins per Peptide Distribution}

\description{This function draws histograms for the distribution of the number of proteins associated to the peptides.}

\usage{mcq.plot.peptide.sharing(object, file=NULL)}


\arguments{
	\item{object}{an object of class 'mcqProtPep' or 'mcq.skyline'}
	\item{file}{a character vector indicating the name of the pdf file where to export the histograms (e.g. "mygraph.pdf"). By default, the graphs are displayed on the screen}
}

\details{The function 'mcq.plot.peptide.sharing' draws two histograms. The first is built considering all the peptides and the second is built considering only the peptides that are shared by two or more proteins. The second one is more convenient to look at shared peptides which are generally not many compared to the peptides associated to only one protein.}

\value{The function 'mcq.plot.peptide.sharing' returns two graphs that are displayed on the screen when the file argument is NULL or that are exported as a pdf file when the file argument is filled in.}

\references{}

\author{}

\note{}


\seealso{'hist'}

\examples{
# Preliminary step: load the example dataset
	data(extraction)

# Launch the 'mcq.plot.intensity.distribution' function with default parameters
	mcq.plot.peptide.sharing(protPep)


}






