library("MassChroqR")
packageVersion("MassChroqR")

cat(paste(Sys.time(),"\n",sep =""))

dir.create("/tmp/test_MassChroqR", showWarnings = FALSE)

dir.create("/tmp/test_MassChroqR/test_mcq_compute_protein_value", showWarnings = FALSE)

setwd ("/tmp/test_MassChroqR/test_mcq_compute_protein_value")

cat("Test mcq_compute_protein_value\n")

if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- mcq.read.protpep("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", "/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")

	# import des métadata
	metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}

cat("\n")
cat("#####################################\n")
cat("      initial summary protPep\n")
cat("#####################################\n")
summary(protPep)
cat("\n")


# Computation of the protein abundances as the sum of the peptide intensities
qprot <- mcq.protquantity(protPep)

cat("\n")
cat("#####################################\n")
cat("      function mcq.drop.protquantity.sd \n")
cat("#####################################\n")

# test incorrect object (protPep)
result <- tryCatch({

			qprot <- mcq.drop.protquantity.sd(protPep,cutoff=0.05)


		}, warning = function(war) {

			# warning handler picks up where error was generated
			cat(paste("MY_WARNING:  ",war))
			return()

		}, error = function(err) {

			# error handler picks up where error was generated
			cat(paste("MY_ERROR:  ",err))

			cat ("*********************************************\n")
			cat (" error message expected OK\n")
			cat ("*********************************************\n")

			return()

		})

#  Removal of proteins showing little variation of abundance. Use the plot produced by the mcq.plot.protein.value.sd function to decide on the cut-off to use (e.g. here, proteins for which the absolute value of standard deviation of abundance is lower than 0.05 are removed)
qprot <- mcq.drop.protquantity.sd(qprot,cutoff=0.05)

if(length(unique(qprot@protval$protein))==1792){
	cat("\n")
	cat("      nb proteins = 1792  OK \n")

}else{
	cat("\n")
	cat("      ERROR nb proteins !=  1792 \n")
	cat(length(unique(qprot@protval$protein)))
	cat("\n")

}

cat("\n")
cat("#####################################\n")
cat("      function mcq.replace.na.protein.value.by.min \n")
cat("#####################################\n")

############# Imputation of missing protein abundance by the minimum abundance obtained for this protein in the whole experiment. 

	cat("\n")
	cat("      Initial summary qprot\n")
	summary(qprot)
	cat("\n")

	qprot <- mcq.replace.na.protein.value.by.min(qprot)

if(length(unique(qprot@protval$protein))==1792){
	cat("\n")
	cat("      nb proteins = 1792  OK \n")

}else{
	cat("\n")
	cat("      ERROR nb proteins !=  1792 \n")
	cat(length(unique(qprot@protval$protein)))
	cat("\n")

}

	compar = mcq.get.compar(qprot)
	
if(sum(is.na(compar))==0){
	cat("\n")
	cat("      no missing data => OK \n")
}else{
	cat("\n")
	cat("      ERROR there is missing data still\n")
	cat(sum(is.na(compar)))
	cat("\n")
}
	cat("\n")
	cat("      Final summary qprot\n")
	summary(qprot)
	cat("\n")
