library("MassChroqR")
packageVersion("MassChroqR")

cat(paste(Sys.time(),"\n",sep =""))

dir.create("/tmp/test_MassChroqR", showWarnings = FALSE)

dir.create("/tmp/test_MassChroqR/test_mcq_drop_uncorrelated_peptides", showWarnings = FALSE)

setwd ("/tmp/test_MassChroqR/test_mcq_drop_uncorrelated_peptides")


cat ("*********************************************\n")
cat (" test mcq drop_uncorrelated_peptides \n")
cat ("*********************************************\n")


if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- mcq.read.protpep("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", "/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")

	# import des métadata
	metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}


# in mcq_peptide_correlation.R
protpep.corr <- mcq.drop.uncorrelated.peptides(protPep, "extraction")

cat("summary protpep.corr\n")
summary(protpep.corr)


if(length(unique(protpep.corr@proteins$protein))==1693){
	cat("\n")
	cat("#####################################\n")
	cat("     mcq.drop.uncorrelated.peptides nb prot = 1693  OK \n")
	cat("#####################################\n")

}else{
	cat("\n")
	cat("#####################################\n")
	cat("      ERROR mcq.drop.uncorrelated.peptides nb prot != 1693  \n")
	cat(length(unique(protpep.corr@proteins$protein)))
	cat("\n")
	cat("#####################################\n")

}

cat ("*********************************************\n")
cat (" mcq.drop.uncorrelated.peptides(protPep, \"extraction\") OK\n")
cat ("*********************************************\n")
