library("MassChroqR")
packageVersion("MassChroqR")

cat(paste(Sys.time(),"\n",sep =""))

dir.create("/tmp/test_MassChroqR", showWarnings = FALSE)

dir.create("/tmp/test_MassChroqR/test_mcq_plot_peptide", showWarnings = FALSE)

setwd ("/tmp/test_MassChroqR/test_mcq_plot_peptide")


cat ("*********************************************\n")
cat (" test mcq plot peptide functions \n")
cat ("*********************************************\n")



if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- mcq.read.protpep("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_prot.tsv", "/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/XIC_result_pep.tsv")

	# import des métadata
	metadata <- mcq.read.metadata("/gorgone/pappso/formation/Novembre2016/TD/resultats_masschroq/metadata.ods")

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}

# in mcq_repeatability.R :
mcq.plot.peptide.reproducibility(protPep, file="PeptideRepetables.pdf")

cat ("*********************************************\n")
cat (" mcq.plot.peptide.reproducibility OK\n")
cat ("*********************************************\n")



